#!/bin/sh

# version 2.2.2 install 
echo "start v2.2.2 update"

# v1.2.x --> v2.2.2
. /etc/scr1800-release
echo "Current Firmware version is $SW_VERSION"
cat /etc/scr1800-release | grep -e "SW_VERSION=\"1.0" -e "SW_VERSION=\"1.1" >/dev/null
if [ $? = 0 ]; then
        echo "Please update to 1.2.0"
        echo "ERROR: Package update is canceled"
        exit 1
fi

#rm -rf /boot/zImage-4.1.15+gb63f3f5

# disk packages
#rpm -i e2fsprogs-1.42.99+1.43+git0+0f26747167-r0.cortexa7hf_neon.rpm
#rpm -i e2fsprogs-badblocks-1.42.99+1.43+git0+0f26747167-r0.cortexa7hf_neon.rpm
#rpm -i e2fsprogs-e2fsck-1.42.99+1.43+git0+0f26747167-r0.cortexa7hf_neon.rpm
#rpm -i e2fsprogs-mke2fs-1.42.99+1.43+git0+0f26747167-r0.cortexa7hf_neon.rpm
rpm -i e2fsprogs-resize2fs-1.42.99+1.43+git0+0f26747167-r0.cortexa7hf_neon.rpm
rpm -i parted-3.2-r1.cortexa7hf_neon.rpm
#rpm -i libcom-err2-1.42.99+1.43+git0+0f26747167-r0.cortexa7hf_neon.rpm
#rpm -i libe2p2-1.42.99+1.43+git0+0f26747167-r0.cortexa7hf_neon.rpm
#rpm -i libext2fs2-1.42.99+1.43+git0+0f26747167-r0.cortexa7hf_neon.rpm
#rpm -i libss2-1.42.99+1.43+git0+0f26747167-r0.cortexa7hf_neon.rpm

# resize (end 200MB)
size=`df / | grep root | awk '{print $2}'`
if [ $size -lt 120000 ]; then
    sync
    /usr/sbin/parted -s /dev/mmcblk0 resizepart 2 200
    /sbin/resize2fs /dev/mmcblk0p2
    sync
fi 

# other packages
rpm -i dosfstools-3.0.28-r0.cortexa7hf_neon.rpm
rpm -i avahi-locale-ja-0.6.32-r0.cortexa7hf_neon.rpm
rpm -i fsl-rc-local-1.0-r0.cortexa7hf_neon.rpm
rpm -i glibc-binary-localedata-ja-jp-2.23-r0.cortexa7hf_neon.rpm
rpm -i glibc-locale-ja-2.23-r0.cortexa7hf_neon.rpm
#rpm -i haveged-1.9.1-r0.cortexa7hf_neon.rpm
#rpm -i hostapd-2.6-r0.cortexa7hf_neon.rpm
rpm -i i2c-tools-3.1.2-r0.cortexa7hf_neon.rpm
rpm -i libgpg-error-locale-ja-1.21-r0.cortexa7hf_neon.rpm
rpm -i libidn-locale-ja-1.32-r0.cortexa7hf_neon.rpm

# backup login-password
cp /etc/lighttpd/.lighttpdpassword /tmp/bkup_pass
rpm -i lighttpd-1.4.39-r0.cortexa7hf_neon.rpm
rpm -i lighttpd-module-setenv-1.4.39-r0.cortexa7hf_neon.rpm

rpm -i locale-base-ja-jp-2.23-r0.cortexa7hf_neon.rpm
rpm -i mailx-12.5+5-r0.cortexa7hf_neon.rpm
rpm -i shadow-locale-ja-4.2.1-r0.cortexa7hf_neon.rpm
rpm -i sudo-locale-ja-1.8.15-r0.cortexa7hf_neon.rpm
rpm -i util-linux-locale-ja-2.27.1-r0.cortexa7hf_neon.rpm
#rpm -i wpa-supplicant-2.6-r0.cortexa7hf_neon.rpm
#rpm -i wpa-supplicant-cli-2.6-r0.cortexa7hf_neon.rpm
#rpm -i wpa-supplicant-passphrase-2.6-r0.cortexa7hf_neon.rpm

rpm -i discover-cam-0.1-r0.cortexa7hf_neon.rpm
rpm -i http-scr1800-0.1-r0.cortexa7hf_neon.rpm
rpm -i init-ifupdown-1.0-r7.cortexa7hf_neon.rpm
rpm -i lte-utils-1.0-r0.cortexa7hf_neon.rpm
rpm -i read-hwinfo-0.1-r0.cortexa7hf_neon.rpm
rpm -i rtspProxyClient-2.1.0-r0.cortexa7hf_neon.rpm
rpm -i safiecam-0.1-r0.cortexa7hf_neon.rpm
rpm -i setup-netcfg-0.1-r0.cortexa7hf_neon.rpm
rpm -i setup-security-0.1-r0.cortexa7hf_neon.rpm
rpm -i update-pkg-0.1-r0.cortexa7hf_neon.rpm

# clean up rpm
rm -f *.rpm

# recover login-password
cp /tmp/bkup_pass /etc/lighttpd/.lighttpdpassword
chown www-data:www-data /etc/lighttpd/.lighttpdpassword

# updated files, initscript, sysvinit package
cp checkroot.sh /etc/init.d/checkroot.sh
cp rcS.default  /etc/default/rcS


# kernel and device tree
echo "check boot-fs"
/sbin/fsck.vfat -a /dev/mmcblk0p1
mkdir /tmp/fat
mount -t vfat /dev/mmcblk0p1 /tmp/fat
cp zImage /tmp/fat/zImage
cp zImage-imx6ul-skkcam.dtb /tmp/fat/imx6ul-skkcam.dtb
rm -f zImage
rm -f zImage-imx6ul-skkcam.dtb
sync
umount /tmp/fat


# make link for rc.local, update-pkg
cd /etc/rc2.d
ln -s ../init.d/rc.local S99rc.local 
ln -s ../init.d/update-pkg S99update-pkg
cd /etc/rc3.d
ln -s ../init.d/rc.local S99rc.local 
ln -s ../init.d/update-pkg S99update-pkg
cd /etc/rc4.d
ln -s ../init.d/rc.local S99rc.local 
ln -s ../init.d/update-pkg S99update-pkg
cd /etc/rc5.d
ln -s ../init.d/rc.local S99rc.local 
ln -s ../init.d/update-pkg S99update-pkg


# network config
if [ ! -e /www/pages/user.cfg ]; then
    cp /etc/setup-netcfg/user.cfg /www/pages/user.cfg
fi
sync

echo "update complete"
exit 0

