#!/bin/sh -e

PATH="/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin"

# $1 : 0:use last config, 1:restore default
# $2 : eth0 mac address
# $3 : eth1 mac address
# $4 : usb-ether use
use_def=$1
eth_mac0=$2
eth_mac1=$3
eth_usb=$4

# load config file
. /etc/setup-netcfg/user.cfg

# force ap when restore mode
if [ $use_def -eq 1 ]; then
	wlan_mode="AP"
fi


#
# /etc/network/interfaces
#
CFG_FILE=/etc/network/interfaces
cp /etc/setup-netcfg/default/interfaces.lo $CFG_FILE


# usb0
if [ $inet_if = "LTE" ]; then
	echo "auto usb0"            >> $CFG_FILE
	echo ""                     >> $CFG_FILE
	echo "iface usb0 inet dhcp" >> $CFG_FILE
fi
echo "" >> $CFG_FILE


# eth0
if [ $inet_if = "ETH0" ] && [ $inet_dhcp = "STATIC" ]; then
	echo "auto eth0"                                 >> $CFG_FILE
	echo ""                                          >> $CFG_FILE
	echo "iface eth0 inet static"                    >> $CFG_FILE
	echo "    address $inet_address"                 >> $CFG_FILE
	echo "    netmask $inet_netmask"                 >> $CFG_FILE
	echo "    gateway $inet_gateway"                 >> $CFG_FILE
	echo "    dns-nameservers $inet_dns1 $inet_dns2" >> $CFG_FILE
elif [ $inet_if != "ETH0" ]; then
	echo "iface eth0 inet static"                    >> $CFG_FILE
	echo "    address 0.0.0.0"                       >> $CFG_FILE
	echo "    netmask $br0_netmask"                  >> $CFG_FILE
else
	echo "auto eth0"                                 >> $CFG_FILE
	echo ""                                          >> $CFG_FILE
	echo "iface eth0 inet dhcp"                      >> $CFG_FILE
fi

echo "    hwaddress ether $eth_mac0" >> $CFG_FILE
echo "" >> $CFG_FILE


# eth1
if [ $inet_if = "ETH1" ] && [ $inet_dhcp = "STATIC" ]; then
	echo "auto eth1"                                 >> $CFG_FILE
	echo ""                                          >> $CFG_FILE
	echo "iface eth1 inet static"                    >> $CFG_FILE
	echo "    address $inet_address"                 >> $CFG_FILE
	echo "    netmask $inet_netmask"                 >> $CFG_FILE
	echo "    gateway $inet_gateway"                 >> $CFG_FILE
	echo "    dns-nameservers $inet_dns1 $inet_dns2" >> $CFG_FILE
elif [ $inet_if != "ETH1" ]; then
	echo "iface eth1 inet static"                    >> $CFG_FILE
	echo "    address 0.0.0.0"                       >> $CFG_FILE
	echo "    netmask $br0_netmask"                  >> $CFG_FILE
else
	echo "auto eth1"                                 >> $CFG_FILE
	echo ""                                          >> $CFG_FILE
	echo "iface eth1 inet dhcp"                      >> $CFG_FILE
fi

echo "    hwaddress ether $eth_mac1" >> $CFG_FILE
echo "" >> $CFG_FILE


# wlan
if [ $inet_if = "WLAN" ] && [ $wlan_mode = "STA" ]; then
	echo "auto wlan0"  >> $CFG_FILE
	echo ""            >> $CFG_FILE

	if [ $inet_dhcp = "STATIC" ]; then
		echo "iface wlan0 inet static"                   >> $CFG_FILE
		echo "    wpa-driver nl80211"                    >> $CFG_FILE
		echo "    wpa-conf /etc/wpa_supplicant.conf"     >> $CFG_FILE
		echo "    address $inet_address"                 >> $CFG_FILE
		echo "    netmask $inet_netmask"                 >> $CFG_FILE
		echo "    gateway $inet_gateway"                 >> $CFG_FILE
		echo "    dns-nameservers $inet_dns1 $inet_dns2" >> $CFG_FILE
	else
		echo "iface wlan0 inet dhcp"                     >> $CFG_FILE
		echo "    wpa-driver nl80211"                    >> $CFG_FILE
		echo "    wpa-conf /etc/wpa_supplicant.conf"     >> $CFG_FILE
	fi
fi

if [ $inet_if != "WLAN" ] && [ $wlan_mode = "AP" ]; then
		echo "iface wlan0 inet manual"                   >> $CFG_FILE
fi

echo "" >> $CFG_FILE


# bridge
echo "auto br0"                              >> $CFG_FILE
echo ""                                      >> $CFG_FILE
echo "iface br0 inet static"                 >> $CFG_FILE
echo "    address $br0_address"              >> $CFG_FILE
echo "    netmask $br0_netmask"              >> $CFG_FILE



#
# NTP
#
sed -e s/@NTP_SERVER_URL@/$ntp_url/ /etc/setup-netcfg/conf/ntp.conf > /etc/ntp.conf



#
# lte monitor
#
if [ $inet_if = "LTE" ]; then
	cp /etc/setup-netcfg/conf/crond_usb0_check /etc/cron.d/usb0_check
fi

#
# dnsmasq
#
cp /etc/setup-netcfg/conf/crond_dnsmasq /etc/cron.d/crond_dnsmasq
cp /etc/setup-netcfg/conf/udhcpc-50default /etc/udhcpc.d/50default


#
# usb-eth : option interface
#
if [ -z "$eth_usb" ]; then
	exit 0
fi

echo "" >> $CFG_FILE

if [ $inet_if = "ETH-USB" ] && [ $inet_dhcp = "STATIC" ]; then
	echo "auto $eth_usb"                             >> $CFG_FILE
	echo ""                                          >> $CFG_FILE
	echo "iface $eth_usb inet static"                >> $CFG_FILE
	echo "    address $inet_address"                 >> $CFG_FILE
	echo "    netmask $inet_netmask"                 >> $CFG_FILE
	echo "    gateway $inet_gateway"                 >> $CFG_FILE
	echo "    dns-nameservers $inet_dns1 $inet_dns2" >> $CFG_FILE
elif [ $inet_if != "ETH-USB" ]; then
	echo "iface $eth_usb inet static"                >> $CFG_FILE
	echo "    address 0.0.0.0"                       >> $CFG_FILE
	echo "    netmask $br0_netmask"                  >> $CFG_FILE
else
	echo "auto $eth_usb"                             >> $CFG_FILE
	echo ""                                          >> $CFG_FILE
	echo "iface $eth_usb inet dhcp"                  >> $CFG_FILE
fi
