#!/bin/sh

if [ -e /etc/openvpn/server/.moved ]; then
	exit 0
fi

if [ ! -e /etc/openvpn/server ]; then
	mkdir -p /etc/openvpn/server
fi

touch /etc/openvpn/server/.moved
sync

if [ ! -e /etc/openvpn/server.conf ]; then
	exit 0
fi

# move old server files to new directory
sed -i -e 's/openvpn\/ca.crt/openvpn\/server\/ca.crt/' /etc/openvpn/server.conf
sed -i -e 's/openvpn\/dh2048.pem/openvpn\/server\/dh2048.pem/' /etc/openvpn/server.conf
sed -i -e 's/openvpn\/server.crt/openvpn\/server\/server.crt/' /etc/openvpn/server.conf
sed -i -e 's/openvpn\/server.key/openvpn\/server\/server.key/' /etc/openvpn/server.conf

if [ -e /etc/openvpn/ca.crt ] && [ ! -e /etc/openvpn/server/ca.crt ]; then
	mv /etc/openvpn/ca.crt /etc/openvpn/server/
fi
if [ -e /etc/openvpn/dh2048.pem ] && [ ! -e /etc/openvpn/server/dh2048.pem ]; then
	mv /etc/openvpn/dh2048.pem /etc/openvpn/server/
fi
if [ -e /etc/openvpn/server.crt ] && [ ! -e /etc/openvpn/server/server.crt ] ; then
	mv /etc/openvpn/server.crt /etc/openvpn/server/
fi
if [ -e /etc/openvpn/server.key ] && [ ! -e /etc/openvpn/server/server.key ]; then
	mv /etc/openvpn/server.key /etc/openvpn/server/
fi

sync
