#!/bin/sh

# current cfgfile
if [ -z "$1" ]; then
	cfg_file="/etc/setup-netcfg/user.cfg"
else
	cfg_file="$1"
fi
. $cfg_file

# convert 0/1 to false/true for html checkbox
temp_file="/var/tmp/.temp_cbox"

list_cb="use_safie auto_safie use_wifi wlan_hidden use_easyln easyln0_en easyln1_en easyln2_en easyln3_en easyln4_en easyln5_en easyln6_en easyln7_en pf0_en pf1_en pf2_en pf3_en pf4_en pf5_en pf6_en pf7_en pf8_en pf9_en use_dhcp use_rb_ping"

for name in $list_cb; do
	if [ "${!name}" == "0" ]; then
		echo ${name}="false" >> $temp_file
	else
		echo ${name}="true"  >> $temp_file
	fi
done

# override checkbox value
. $temp_file
rm $temp_file

# mail file dir
mail_dir="/www/pages/mail"

# output new cfg by json
echo "{"
echo '  "format_version" : "1.0",'

echo '  "menu" : ['
echo '    {"id" : "wan",           "value" : true},'
echo '    {"id" : "wlan",          "value" : true},'
echo '    {"id" : "sub_app",       "value" : true},'
echo '      {"id" : "safie",         "value"  : true},'
echo '      {"id" : "easylink",      "value"  : true},'
echo '    {"id" : "sub_remote",    "value" : true},'
echo '      {"id" : "portfwd",        "value" : true},'
echo '      {"id" : "ipfilter",       "value" : true},'
echo '      {"id" : "ddns",           "value" : true},'
echo '      {"id" : "ovpn",           "value" : true},'
echo '      {"id" : "status",         "value" : true},'
echo '    {"id" : "sub_expert",    "value" : true},'
echo '      {"id" : "poe",            "value" : true},'
echo '      {"id" : "sinput",         "value" : true},'
echo '      {"id" : "local_net",      "value" : true},'
echo '      {"id" : "ntp_server",     "value" : true},'
echo '      {"id" : "reboot_sched",   "value" : true},'
echo '      {"id" : "reboot_ping",    "value" : true},'
echo '      {"id" : "login_passwd",   "value" : true},'
echo '    {"id" : "sub_logs",      "value" : true},'
echo '      {"id" : "syslog",         "value" : true},'
echo '      {"id" : "ltelog",         "value" : true},'
echo '      {"id" : "atlog",          "value" : true},'
echo '    {"id" : "sub_system",    "value" : true},'
echo '      {"id" : "system_reboot",  "value" : true},'
echo '      {"id" : "conf_save",      "value" : true},'
echo '      {"id" : "fw_upload",      "value" : false}'
echo '  ],'

echo '  "wan" : ['
echo "    { \"id\":\"inet\",    \"value\":\"$inet_if\" },"
echo "    { \"id\":\"dhcp\",    \"value\":\"$inet_dhcp\" },"
echo "    { \"id\":\"address\", \"value\":\"$inet_address\" },"
echo "    { \"id\":\"netmask\", \"value\":\"$inet_netmask\" },"
echo "    { \"id\":\"gateway\", \"value\":\"$inet_gateway\" },"
echo "    { \"id\":\"dns1\",    \"value\":\"$inet_dns1\" },"
echo "    { \"id\":\"dns2\",    \"value\":\"$inet_dns2\" }"
echo '  ],'

echo '  "lte" : ['
echo "    { \"id\":\"enable\",  \"value\":true },"
echo "    { \"id\":\"carrier\", \"value\":\"DOCOMO\" },"
echo "    { \"id\":\"apn\",      \"value\":\"$lte_apn\" },"
echo "    { \"id\":\"user\",     \"value\":\"$lte_user\" },"
echo "    { \"id\":\"password\", \"value\":\"$lte_password\" },"
echo "    { \"id\":\"auth\",     \"value\":\"$lte_auth\" }"
echo '  ],'

echo '  "wlan" : ['
echo "    { \"id\":\"enable\",  \"value\":$use_wifi },"
echo "    { \"id\":\"mode\",    \"value\":\"$wlan_mode\" },"
echo "    { \"id\":\"ssid\",    \"value\":\"$wlan_ssid\" },"
echo "    { \"id\":\"psk\",     \"value\":\"$wlan_psk\" },"
echo "    { \"id\":\"proto\",   \"value\":\"$wlan_proto\" },"
echo "    { \"id\":\"channel\", \"value\":\"$wlan_channel\" },"
echo "    { \"id\":\"hidden\",  \"value\":$wlan_hidden }"
echo '  ],'

echo '  "br0" : ['
echo "    { \"id\":\"address\",    \"value\":\"$br0_address\" },"
echo "    { \"id\":\"netmask\",    \"value\":\"$br0_netmask\" },"
echo "    { \"id\":\"dhcp_use\",   \"value\":$use_dhcp },"
echo "    { \"id\":\"dhcp_start\", \"value\":\"$dhcpd_range_start\" },"
echo "    { \"id\":\"dhcp_end\",   \"value\":\"$dhcpd_range_end\" }"
echo '  ],'

echo '  "ntp" : ['
echo "    { \"id\":\"url\", \"value\":\"$ntp_url\" }"
echo '  ],'

# http password
http_passwd=`cat /etc/lighttpd/.lighttpdpassword`
echo '  "http" : ['
echo "    { \"id\":\"password\", \"value\":\"${http_passwd#*:}\" }"
echo '  ],'

# openvpn
if [ "$vpn_mode" = "disable" ]; then
	vpn_enable="false"
	vpn_mode="TUN"
else
	vpn_enable="true"
	vpn_mode="$vpn_mode"
fi
echo '  "ovpn" : ['
echo "    { \"id\":\"enable\",  \"value\":$vpn_enable },"
echo "    { \"id\":\"mode\",    \"value\":\"$vpn_mode\" },"
echo "    { \"id\":\"cl_conf\", \"value\":\"$vpncl_conf\" }"
echo '  ],'

# ddns
if [ "$ddns_prov" = "disable" ]; then
	ddns_enable="false"
	ddns_prov=""
else
	ddns_enable="true"
fi

echo '  "ddns" : ['
echo "    { \"id\":\"enable\", \"value\":$ddns_enable },"
echo "    { \"id\":\"prov\",   \"value\":\"$ddns_prov\" },"
echo "    { \"id\":\"domain\", \"value\":\"$ddns_domain\" },"
echo "    { \"id\":\"user\",   \"value\":\"$ddns_user\" },"
echo "    { \"id\":\"passwd\", \"value\":\"$ddns_passwd\" }"
echo '  ],'

# port forward
echo '  "portfwd" : ['
for n in `seq 0 9`; do
	echo '    ['
	en="pf${n}_en"
	ip="pf${n}_ip"
	port="pf${n}_port"
	proto="pf${n}_type"
	mmap="pf${n}_mmap"
	echo "      { \"id\":\"enable\", \"value\":${!en} },"
	echo "      { \"id\":\"daddr\",  \"value\":\"${!ip}\" },"
	echo "      { \"id\":\"dport\",  \"value\":\"${!port}\" },"
	echo "      { \"id\":\"proto\",  \"value\":\"${!proto}\" },"
	echo "      { \"id\":\"port\",   \"value\":\"${!mmap}\" },"
	echo "      { \"id\":\"saddr\",  \"value\":\"any\" }"
	echo -n '    ]'
	if [ $n -ne 9 ]; then
		echo ','
	fi
done
echo '  ],'

# ip filter
echo '  "ipfilter": ['
echo '    ['
echo '      {"id" : "prio",    "value" : "1000"},'
echo '      {"id" : "type",    "value" : "DROP"},'
echo '      {"id" : "dir",     "value" : "INPUT"},'
echo '      {"id" : "saddr",   "value" : "any"},'
echo '      {"id" : "sport",   "value" : "137:139"},'
echo '      {"id" : "proto",   "value" : "UDP"},'
echo '      {"id" : "daddr",   "value" : "any"},'
echo '      {"id" : "dport",   "value" : "any"}'
echo '    ],'
echo '    ['
echo '      {"id" : "prio",    "value" : "1001"},'
echo '      {"id" : "type",    "value" : "DROP"},'
echo '      {"id" : "dir",     "value" : "INPUT"},'
echo '      {"id" : "saddr",   "value" : "any"},'
echo '      {"id" : "sport",   "value" : "137:139"},'
echo '      {"id" : "proto",   "value" : "TCP"},'
echo '      {"id" : "daddr",   "value" : "any"},'
echo '      {"id" : "dport",   "value" : "any"}'
echo '    ]'
echo '  ],'


# safie
echo '  "safie_cfg" : ['
echo "    { \"id\":\"enable\",    \"value\":$use_safie },"
echo "    { \"id\":\"auto\",      \"value\":$auto_safie },"
echo "    { \"id\":\"scr_tk\",    \"value\":\"$scr_tk\" },"
echo "    { \"id\":\"cam_count\", \"value\":\"$cam_count\" }"
echo '  ],'

echo '  "safie_cam" : ['
for n in `seq 1 4`; do
	user="cam${n}_user"
	passwd="cam${n}_passwd"
	tk="cam${n}_tk"
	mac="cam${n}_mac"
	ip="cam${n}_ip"
	echo '    ['
	echo "      { \"id\":\"user\",   \"value\":\"${!user}\" },"
	echo "      { \"id\":\"passwd\", \"value\":\"${!passwd}\" },"
	echo "      { \"id\":\"tk\",     \"value\":\"${!tk}\" },"
	echo "      { \"id\":\"mac\",    \"value\":\"${!mac}\" },"
	echo "      { \"id\":\"ip\",     \"value\":\"${!ip}\" }"
	echo -n '    ]'
	if [ $n -ne 4 ]; then
		echo ','
	fi
done
echo '  ],'


# easylink
echo '  "easylink" : ['
for n in `seq 0 7`; do
	echo '    ['
	en="easyln${n}_en"
	ip="easyln${n}_ip"
	port="easyln${n}_port"
	proto="easyln${n}_type"
	mmap="easyln${n}_mmap"
	echo "      { \"id\":\"enable\", \"value\":${!en} },"
	echo "      { \"id\":\"port\",   \"value\":\"${!mmap}\" },"
	echo "      { \"id\":\"daddr\",  \"value\":\"${!ip}\" },"
	echo "      { \"id\":\"dport\",  \"value\":\"${!port}\" },"
	echo "      { \"id\":\"proto\",  \"value\":\"${!proto}\" }"
	echo -n '    ]'
	if [ $n -ne 7 ]; then
		echo ','
	fi
done
echo '  ],'


# sinput
if [ "$sinp_enb_p2_safie"  = "enable" ]; then
	sinp_enb_p2_safie="1"
else
	sinp_enb_p2_safie="0"
fi
if [ "$sinp_enb_p2_mail"  = "enable" ]; then
	sinp_enb_p2_mail="1"
else
	sinp_enb_p2_mail="0"
fi
if [ "$sinp_enb_p4_safie"  = "enable" ]; then
	sinp_enb_p4_safie="1"
else
	sinp_enb_p4_safie="0"
fi
if [ "$sinp_enb_p4_mail"  = "enable" ]; then
	sinp_enb_p4_mail="1"
else
	sinp_enb_p4_mail="0"
fi

echo '  "sinp_p2" : ['
echo "    { \"id\":\"safie\", \"value\":\"$sinp_enb_p2_safie\" },"
echo "    { \"id\":\"mail\",  \"value\":\"$sinp_enb_p2_mail\" },"
echo "    { \"id\":\"type\",  \"value\":\"$sinp_typ_p2\" },"
echo "    { \"id\":\"sec\",   \"value\":\"$sinp_sec_p2\" }"
echo '  ],'

echo '  "sinp_p4" : ['
echo "    { \"id\":\"safie\", \"value\":\"$sinp_enb_p4_safie\" },"
echo "    { \"id\":\"mail\",  \"value\":\"$sinp_enb_p4_mail\" },"
echo "    { \"id\":\"type\",  \"value\":\"$sinp_typ_p4\" },"
echo "    { \"id\":\"sec\",   \"value\":\"$sinp_sec_p4\" }"
echo '  ],'

echo '  "mail" : ['
echo "    { \"id\":\"addr1\",  \"value\":\"$sinp_addr_1\" },"
echo "    { \"id\":\"addr2\",  \"value\":\"$sinp_addr_2\" },"
echo "    { \"id\":\"addr3\",  \"value\":\"$sinp_addr_3\" },"
echo "    { \"id\":\"myaddr\", \"value\":\"$sinp_myaddr\" },"
echo "    { \"id\":\"smtp\",   \"value\":\"$sinp_smtp\" },"
echo "    { \"id\":\"user\",   \"value\":\"$sinp_user\" },"
echo "    { \"id\":\"passwd\", \"value\":\"$sinp_passwd\" }"
echo '  ],'

echo '  "mail_p2" : ['
echo -n '    {"id" : "sub",  "value" : "'; cat $mail_dir/sub_p2.txt; echo '"},'
echo -n '    {"id" : "body", "value" : "'; cat $mail_dir/body_p2.txt; echo '"}'
echo '  ],'

echo '  "mail_p4" : ['
echo -n '    {"id" : "sub",  "value" : "'; cat $mail_dir/sub_p4.txt; echo '"},'
echo -n '    {"id" : "body", "value" : "'; cat $mail_dir/body_p4.txt; echo '"}'
echo '  ],'


# reboot
if [ "$rb_cfg" = "disable" ]; then
	rb_enable="false"
	rb_cfg="month"
else
	rb_enable="true"
fi

echo '  "reboot_sched" : ['
echo "    { \"id\":\"enable\",          \"value\":$rb_enable },"
echo "    { \"id\":\"mode\",            \"value\":\"$rb_cfg\" },"
echo "    { \"id\":\"day\",             \"value\":\"$rb_day\" },"
echo "    { \"id\":\"hour\",            \"value\":\"$rb_hour\" },"
echo "    { \"id\":\"minute\",          \"value\":\"$rb_minute\" },"
echo "    { \"id\":\"periodic_day\",    \"value\":\"$rb_periodic_day\" },"
echo "    { \"id\":\"periodic_hour\",   \"value\":\"$rb_periodic_hour\" },"
echo "    { \"id\":\"periodic_minute\", \"value\":\"$rb_periodic_minute\" }"
echo '  ],'

echo '  "reboot_ping" : ['
echo "    { \"id\":\"enable\", \"value\":$use_rb_ping },"
echo "    { \"id\":\"dest\",   \"value\":\"$ping_dest\" },"
echo "    { \"id\":\"sec\",    \"value\":\"$ping_sec\" },"
echo "    { \"id\":\"nfail\",  \"value\":\"$ping_nfail\" },"
echo "    { \"id\":\"nrboot\", \"value\":\"$ping_nrboot\" }"
echo '  ]'

echo "}"

