#!/bin/sh

# mount temporary filesystems
mount -n -t devtmpfs devtmpfs /dev
mount -n -t proc     proc     /proc
mount -n -t sysfs    sysfs    /sys
mount -n -t tmpfs    tmpfs    /run

dir="/mnt"
if [ ! -e $dir ]; then
	mkdir -p $dir
fi

mount -o ro /dev/mmcblk0p3 $dir
if [ $? -ne 0 ]; then
	echo b > /proc/sysrq-trigger
	exit 1
fi

. "$dir/file_list"

cp $dir/$fw_file .
if [ $? -ne 0 ]; then
	echo b > /proc/sysrq-trigger
	exit 1
fi

umount $dir
if [ $? -ne 0 ]; then
	echo b > /proc/sysrq-trigger
	exit 1
fi

gzip -d -c $fw_file | dd of=/dev/mmcblk0 conv=fsync bs=1M

sleep 5

# reboot
echo b > /proc/sysrq-trigger

exit 0
