#!/bin/sh

fw_file=`tar tzf $1`
if [ -z "$fw_file" ]; then
	echo "no firmware file"
	exit 1
fi

if [ "$fw_file" != "firmware.tar" ];  then
	tar xvzf $1 -C /etc/update-pkg/files
	/bin/sync

	echo "Restarting the system..."
	/sbin/reboot
else
	dir="/var/tmp/upgrade"
	if [ ! -e $dir ]; then
		mkdir -p $dir
	fi

	/bin/mount /dev/mmcblk0p3 $dir
	if [ $? -ne 0 ]; then
		echo "Must Update to V2.2.0 first"
		rm -f $1
		exit 1
	fi
	tar xvzf $1 -C ${dir}
	rm -f $1
	/bin/umount $dir

	# setup firmware upgrade files
	/etc/update-pkg/fw_setup.sh $fw_file
	if [ $? -ne 0 ]; then
		echo "bad firmware file"
		exit 1
	fi

	# firmware upgrade
	cp /etc/update-pkg/fw_write.sh /var/tmp/fw_write.sh
	(/var/tmp/fw_write.sh &> /dev/null)&
fi
