#!/bin/sh

PATH="/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin"
config_file=/etc/setup-netcfg/user.cfg

# load config file
. $config_file

#for update-pkg
if [ -z "$sinp_typ_p2" ] || [ -z "$sinp_typ_p4" ] ; then 
	exit 0
fi


if [ "$sinp_enb_p2_safie" = "disable" ] && [ "$sinp_enb_p4_safie" = "disable" ] && [ "$sinp_enb_p2_mail" = "disable" ] && [ "$sinp_enb_p4_mail" = "disable" ]; then
	exit 0
fi

tim_p2=`expr $sinp_sec_p2 \* 10`
tim_p4=`expr $sinp_sec_p4 \* 10`
count_p2=0
count_p4=0
state_p2=0
state_p4=0
detect_p2=0
detect_p4=0
MS100=60000

# $1: pin,  $2:port2, $3:port4 
send_port_inf() {
	#echo "detect Pin$1=$2"
	if [ $1 = 2 ]; then
		if [ "$sinp_enb_p2_safie" = "enable" ]; then
			sh /usr/local/bin/sinp_send_safie.sh $1 $2 $3
		fi
		if [ "$sinp_enb_p2_mail" = "enable" ]; then
			sh /usr/local/bin/sinp_send_mail.sh $1 $2 $3
		fi
	elif [ $1 = 4 ]; then
		if [ "$sinp_enb_p4_safie" = "enable" ]; then
			sh /usr/local/bin/sinp_send_safie.sh $1 $2 $3
		fi
		if [ "$sinp_enb_p4_mail" = "enable" ]; then
			sh /usr/local/bin/sinp_send_mail.sh $1 $2 $3
		fi
	elif [ $1 = 6 ]; then
		if [ "$sinp_enb_p2_safie" = "enable" ]; then
			sh /usr/local/bin/sinp_send_safie.sh $1 $2 $3
		else
			if [ "$sinp_enb_p4_safie" = "enable" ]; then
				sh /usr/local/bin/sinp_send_safie.sh $1 $2 $3
			fi
		fi
		if [ "$sinp_enb_p2_mail" = "enable" ]; then
			sh /usr/local/bin/sinp_send_mail.sh 2 $2 $3
		fi
		if [ "$sinp_enb_p4_mail" = "enable" ]; then
			sh /usr/local/bin/sinp_send_mail.sh 4 $2 $3
		fi
	fi
}



# port-check loop
while :
do
	usleep $MS100
	detect_p2=0
	detect_p4=0

	# read pin2/4
	pin2=`/usr/local/bin/gpio_ctl -r 16`
	pin4=`/usr/local/bin/gpio_ctl -r 17`

	#check pin2
	if [ $state_p2 = 0 ]; then
		# detect-wait state
		if [ "$pin2" = 1 ]; then 
			if [ "$sinp_typ_p2" = "close" ]; then 
				#wait 0-->1
				count_p2=`expr $count_p2 + 1`
				if [ $count_p2 -ge $tim_p2 ]; then
					#detect port-chnage
					detect_p2=1
					state_p2=1
				fi
			fi
		else
			if [ "$sinp_typ_p2" = "open" ]; then 
				#wait 1-->0
				count_p2=`expr $count_p2 + 1`
				if [ $count_p2 -ge $tim_p2 ]; then
					#detect port-chnage
					detect_p2=1
					state_p2=1
				fi
			fi
		fi
	else
		# off-wait state
		if [ "$pin2" = 1 ]; then
			if [ "$sinp_typ_p2" = "open" ]; then 
				count_p2=0
				state_p2=0
			fi
		else
			if [ "$sinp_typ_p2" = "close" ]; then 
				count_p2=0
				state_p2=0
			fi
		fi
	fi

	# check pin4
	if [ $state_p4 = 0 ]; then
		# detect-wait state
		if [ "$pin4" = 1 ]; then 
			if [ "$sinp_typ_p4" = "close" ]; then 
				#wait 0-->1
				count_p4=`expr $count_p4 + 1`
				if [ $count_p4 -ge $tim_p4 ]; then
					#detect port-chnage
					detect_p4=1
					state_p4=1
				fi
			fi
		else
			if [ "$sinp_typ_p4" = "open" ]; then 
				#wait 1-->0
				count_p4=`expr $count_p4 + 1`
				if [ $count_p4 -ge $tim_p4 ]; then
					#detect port-chnage
					detect_p4=1
					state_p4=1
				fi
			fi
		fi
	else
		# off-wait state
		if [ "$pin4" = 1 ]; then
			if [ "$sinp_typ_p4" = "open" ]; then 
				count_p4=0
				state_p4=0
			fi
		else
			if [ "$sinp_typ_p4" = "close" ]; then 
				count_p4=0
				state_p4=0
			fi
		fi
	fi


	# send event
	if [ $detect_p2 = 1 ]; then
		if [ $detect_p4 = 1 ]; then
			send_port_inf 6 "$pin2" "$pin4"
		else
			send_port_inf 2 "$pin2" "$pin4"
		fi
	else
		if [ $detect_p4 = 1 ]; then
			send_port_inf 4 "$pin2" "$pin4"
		fi
	fi

done

exit 0
