#!/bin/sh

PATH="/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin"
discover=/usr/local/bin/discover-cam.sh
config_file=/etc/setup-netcfg/user.cfg
config_path=/etc/setup-netcfg
hwinfo_file=/tmp/hwinfo
prog=safie_cli.sh
prog_name=safiecam
tmp_discover=/tmp/cam.list
#cli_pid=/tmp/cli_pid.list
tmp_tk=/tmp/temp_tk
tmp_token=/tmp/temp_token
tmp_cfg=/tmp/temp_cfg
tmp_info=/tmp/.temp_info
cam_info=/tmp/.cli_info
tmp_arp=/tmp/temp_arp
tmp_ip=/tmp/temp_ip
tmp_ps_ip=/tmp/temp_ps_ip
tmp_ps=/tmp/.tmp_ps
tmp_cli_sts=/tmp/temp_cli_sts
scr_cli=/tmp/scr_cli
#cm_cli1=/tmp/cm_cli1
#cm_cli2=/tmp/cm_cli2
#cm_cli3=/tmp/cm_cli3
#cm_cli4=/tmp/cm_cli4
#dbg_log=/tmp/dbgsafie.log
tmp_config_file=/tmp/temp_config_file

tmp_tk_path=/tmp
tk_path=/etc/setup-netcfg/safie
scr_tk_fname=token_scr
cm_tk_fname=token_cam
cam_status=$tk_path/cam_status
upnp_in="/etc/cam-search.txt"
wsd_in="/etc/cam-wsd.txt"
tmp_wsd="/tmp/.wsd"

scr_pid=0
aa_cnt_scr=0
aa_cnt_cam1=0
aa_cnt_cam2=0
aa_cnt_cam3=0
aa_cnt_cam4=0
run_cnt_scr=0
run_cnt_cam1=0
run_cnt_cam2=0
run_cnt_cam3=0
run_cnt_cam4=0

run_chk_cnt=0
scr_status=0
cam1_status=0
cam2_status=0
cam3_status=0
cam4_status=0
scr_ll_sts=0
cam1_ll_sts=0
cam2_ll_sts=0
cam3_ll_sts=0
cam4_ll_sts=0

#debug
run_cli_flag=0


# load config file
. $config_file
. $hwinfo_file

scr_ip=$br0_address
scr_model=$board_name
scr_sn=$serial_number


if [ "$use_safie" != "1" ]; then
	#echo "dbg: exit $use_safie"
	exit 0
fi



save_cam_info() {
	echo "scr_model=\"$scr_model\"" > $tmp_info
	echo "scr_sn=\"$scr_sn\"" >> $tmp_info
	echo "scr_ip=\"$scr_ip\"" >> $tmp_info
	echo "scr_tk=\"$scr_tk\"" >> $tmp_info
	echo "cam1_model=\"$cam1_model\"" >> $tmp_info
	echo "cam2_model=\"$cam2_model\"" >> $tmp_info
	echo "cam3_model=\"$cam3_model\"" >> $tmp_info
	echo "cam4_model=\"$cam4_model\"" >> $tmp_info
	echo "cam1_sn=\"$cam1_sn\"" >> $tmp_info
	echo "cam2_sn=\"$cam2_sn\"" >> $tmp_info
	echo "cam3_sn=\"$cam3_sn\"" >> $tmp_info
	echo "cam4_sn=\"$cam4_sn\"" >> $tmp_info
	echo "cam1_ip=\"$cam1_ip\"" >> $tmp_info
	echo "cam2_ip=\"$cam2_ip\"" >> $tmp_info
	echo "cam3_ip=\"$cam3_ip\"" >> $tmp_info
	echo "cam4_ip=\"$cam4_ip\"" >> $tmp_info
	echo "cam1_tk=\"$cam1_tk\"" >> $tmp_info
	echo "cam2_tk=\"$cam2_tk\"" >> $tmp_info
	echo "cam3_tk=\"$cam3_tk\"" >> $tmp_info
	echo "cam4_tk=\"$cam4_tk\"" >> $tmp_info
	echo "cam1_port=\"$cam1_port\"" >> $tmp_info
	echo "cam2_port=\"$cam2_port\"" >> $tmp_info
	echo "cam3_port=\"$cam3_port\"" >> $tmp_info
	echo "cam4_port=\"$cam4_port\"" >> $tmp_info
	echo "cam1_mac=\"$cam1_mac\"" >> $tmp_info
	echo "cam2_mac=\"$cam2_mac\"" >> $tmp_info
	echo "cam3_mac=\"$cam3_mac\"" >> $tmp_info
	echo "cam4_mac=\"$cam4_mac\"" >> $tmp_info
	echo "cam1_user=\"$cam1_user\"" >> $tmp_info
	echo "cam2_user=\"$cam2_user\"" >> $tmp_info
	echo "cam3_user=\"$cam3_user\"" >> $tmp_info
	echo "cam4_user=\"$cam4_user\"" >> $tmp_info
	echo "cam1_passwd=\"$cam1_passwd\"" >> $tmp_info
	echo "cam2_passwd=\"$cam2_passwd\"" >> $tmp_info
	echo "cam3_passwd=\"$cam3_passwd\"" >> $tmp_info
	echo "cam4_passwd=\"$cam4_passwd\"" >> $tmp_info
	#cat $tmp_info

}

update_usr_cfg() {
	if [ "$auto_safie" != "1" ]; then
		return 1
	fi

# rw mount
	#/bin/mount -o rw,remount / > /dev/null


# Num of Camera
	grep -v "cam_count" $config_file > $tmp_config_file
	echo "cam_count=\"$cam_count\"" >> $tmp_config_file
	sudo mv $tmp_config_file $config_file

# Camera MAC address
	grep -v "cam._mac" $config_file > $tmp_config_file
	echo "cam1_mac=\"$cam1_mac\"" >> $tmp_config_file
	echo "cam2_mac=\"$cam2_mac\"" >> $tmp_config_file
	echo "cam3_mac=\"$cam3_mac\"" >> $tmp_config_file
	echo "cam4_mac=\"$cam4_mac\"" >> $tmp_config_file
	sudo mv $tmp_config_file $config_file

# Camera IP address
	grep -v "cam._ip" $config_file > $tmp_config_file
	echo "cam1_ip=\"$cam1_ip\"" >> $tmp_config_file
	echo "cam2_ip=\"$cam2_ip\"" >> $tmp_config_file
	echo "cam3_ip=\"$cam3_ip\"" >> $tmp_config_file
	echo "cam4_ip=\"$cam4_ip\"" >> $tmp_config_file
	sudo mv $tmp_config_file $config_file

# Safie Token
	grep -v "._tk" $config_file > $tmp_config_file
	echo "cam1_tk=\"$cam1_tk\"" >> $tmp_config_file
	echo "cam2_tk=\"$cam2_tk\"" >> $tmp_config_file
	echo "cam3_tk=\"$cam3_tk\"" >> $tmp_config_file
	echo "cam4_tk=\"$cam4_tk\"" >> $tmp_config_file
	echo "scr_tk=\"$scr_tk\"" >> $tmp_config_file
	sudo mv $tmp_config_file $config_file

# Camera user
	grep -v "cam._user" $config_file > $tmp_config_file
	echo "cam1_user=\"$cam1_user\"" >> $tmp_config_file
	echo "cam2_user=\"$cam2_user\"" >> $tmp_config_file
	echo "cam3_user=\"$cam3_user\"" >> $tmp_config_file
	echo "cam4_user=\"$cam4_user\"" >> $tmp_config_file
	sudo mv $tmp_config_file $config_file

# Camera passwd
	grep -v "cam._passwd" $config_file > $tmp_config_file
	echo "cam1_passwd=\"$cam1_passwd\"" >> $tmp_config_file
	echo "cam2_passwd=\"$cam2_passwd\"" >> $tmp_config_file
	echo "cam3_passwd=\"$cam3_passwd\"" >> $tmp_config_file
	echo "cam4_passwd=\"$cam4_passwd\"" >> $tmp_config_file
	sudo mv $tmp_config_file $config_file

	sync
# ro mount
	#/bin/mount -o ro,remount / > /dev/null

	return 0
}


reset_discover_cam() {
	cam_sn_1=""
	cam_sn_2=""
	cam_sn_3=""
	cam_sn_4=""
	cam_ip_1=""
	cam_ip_2=""
	cam_ip_3=""
	cam_ip_4=""
	#cam_modelName_1=""
	#cam_modelName_2=""
	#cam_modelName_3=""
	#cam_modelName_4=""
	product_name_1=""
	product_name_2=""
	product_name_3=""
	product_name_4=""
	cam_if_1=""
	cam_if_2=""
	cam_if_3=""
	cam_if_4=""
	cam_mac_1=""
	cam_mac_2=""
	cam_mac_3=""
	cam_mac_4=""
}


count_cfg_cam() {
#	. $tmp_info

	cnt="0"
	if [ -n "$cam1_mac" ]; then
	    cnt=`expr $cnt + 1`
	fi
	if [ -n "$cam2_mac" ]; then
	    cnt=`expr $cnt + 1`
	fi
	if [ -n "$cam3_mac" ]; then
	    cnt=`expr $cnt + 1`
	fi
	if [ -n "$cam4_mac" ]; then
	    cnt=`expr $cnt + 1`
	fi

	return $cnt
}


# $1:camera-serial
_check_sn() {
	#echo "check_sn: $1"
	if [ "$1" = "$cam1_sn" ]; then
		return 0
	elif [ "$1" = "$cam2_sn" ]; then
		return 0
	elif [ "$1" = "$cam3_sn" ]; then
		return 0
	elif [ "$1" = "$cam4_sn" ]; then
		return 0
	fi

	if [ -z "$cam1_sn" ]; then
		return 1
	elif [ -z "$cam2_sn" ]; then
		return 2
	elif [ -z "$cam3_sn" ]; then
		return 3
	elif [ -z "$cam4_sn" ]; then
		return 4
	fi
	return 0
}

# $1:camera-ip
check_cam_idx() {
	#echo "check ip: $1"
	if [ "$1" = "$cam1_ip" ]; then
		return 1
	elif [ "$1" = "$cam2_ip" ]; then
		return 2
	elif [ "$1" = "$cam3_ip" ]; then
		return 3
	elif [ "$1" = "$cam4_ip" ]; then
		return 4
	fi
	return 0
}

# $1:camera-mac
check_cam_mac() {
	#echo "check mac: $1"
	if [ "$1" = "$cam1_mac" ]; then
		return 1
	elif [ "$1" = "$cam2_mac" ]; then
		return 2
	elif [ "$1" = "$cam3_mac" ]; then
		return 3
	elif [ "$1" = "$cam4_mac" ]; then
		return 4
	fi
	return 0
}
# $1:camera-mac
check_regnum() {
	if [ "$1" = "$cam1_mac" ]; then
		return 1
	elif [ "$1" = "$cam2_mac" ]; then
		return 2
	elif [ "$1" = "$cam3_mac" ]; then
		return 3
	elif [ "$1" = "$cam4_mac" ]; then
		return 4
	fi

	if [ -z "$cam1_mac" ]; then
		return 1
	elif [ -z "$cam2_mac" ]; then
		return 2
	elif [ -z "$cam3_mac" ]; then
		return 3
	elif [ -z "$cam4_mac" ]; then
		return 4
	fi
	return 0
}


# mac addr --> ip addr
check_ip() {
	local tmp_scn=/var/tmp/.tmp_scn

	br0_net=${br0_address%%.*}
	sudo /usr/bin/arp-scan -l -I br0 | grep "^$br0_net" > $tmp_arp

	for num in `seq 1 4`; do
		mac=cam${num}_mac
		if [ -n "${!mac}" ]; then
			ipcnt=`cat $tmp_arp | grep "${!mac}" | wc -l`
			if [ $ipcnt -eq 0 ]; then
				continue
			fi
			for cnt in `seq 1 $ipcnt`; do
				arpip=`cat $tmp_arp | grep "${!mac}" | awk '{print $1}' | sed -n -e ${cnt}p`
				if [ "${#arpip}" -gt 15 ]; then
					#echo -n "[`date +"%Y/%m/%d %H:%M:%S"`]" >> $dbg_log
					#echo "ip-err $num, ${#arpip}, ${!mac}, $arpip" >> $dbg_log
					continue
				 fi
				ip=cam${num}_ip
				if [ "${!ip}" != "$arpip" ]; then
					if [ -e /var/tmp/.discover_running ]; then
						continue
					fi
					touch /var/tmp/.discover_running
					uuid=`cat /proc/sys/kernel/random/uuid`
					cat $wsd_in | sed "s/uuid:XXX/uuid:$uuid/g" > $tmp_wsd
					sudo /usr/bin/socat -T1 STDIO UDP4-DATAGRAM:239.255.255.250:3702,bindtodevice=br0 < $tmp_wsd > $tmp_scn
					cat $tmp_scn | grep "$arpip" > /dev/null
					if [ $? = 0 ]; then
						echo "cam${num}_ip=\"$arpip\"" >> $tmp_ip
						#echo -n "[`date +"%Y/%m/%d %H:%M:%S"`]" >> $dbg_log
						#echo "#wsd# $num mac ${!mac}, cam${num}_ip : ${!ip} --> $arpip " >> $dbg_log
					fi
					rm -f /var/tmp/.discover_running
				fi
			done
		fi
	done
	if [ -e $tmp_ip ]; then
		#echo "cam1_ip: $cam1_ip ->" >> $dbg_log
		#echo "cam2_ip: $cam2_ip ->" >> $dbg_log
		#echo "cam3_ip: $cam3_ip ->" >> $dbg_log
		#echo "cam4_ip: $cam4_ip ->" >> $dbg_log
		. $tmp_ip
		#echo "-> $cam1_ip" >> $dbg_log
		#echo "-> $cam2_ip" >> $dbg_log
		#echo "-> $cam3_ip" >> $dbg_log
		#echo "-> $cam4_ip" >> $dbg_log
		rm $tmp_ip
	fi
	rm $tmp_arp
}


# check token file
check_token() {

	tmp_scr_tk=""
	tmp_cam1_tk=""
	tmp_cam2_tk=""
	tmp_cam3_tk=""
	tmp_cam4_tk=""
	if [ -e $tmp_tk ]; then
		rm $tmp_tk
	fi

	# router token
	tk_file=${tmp_tk_path}/${scr_tk_fname}
	bak_file=$tk_path/${scr_tk_fname}
	if [ -e "$tk_file" ]; then
		mn=`cat $tk_file | awk -F, '{print $1}'`
		sn=`cat $tk_file | awk -F, '{print $2}'`
		tk=`cat $tk_file | awk -F, '{print $3}'`
		echo "tmp_scr_tk=$tk" >> $tmp_tk
#
		# rw mount
#		/bin/mount -o rw,remount / > /dev/null
		mv $tk_file $bak_file
		sync
		# ro mount
#		/bin/mount -o ro,remount / > /dev/null
		aa_cnt_scr=0
	fi


	# camera token
	for n in `seq 1 4`; do
		tk_file=${tmp_tk_path}/${cm_tk_fname}${n}
		bak_file=${tk_path}/${cm_tk_fname}${n}
		if [ -e "$tk_file" ]; then
			mn=`cat $tk_file | awk -F, '{print $1}'`
			sn=`cat $tk_file | awk -F, '{print $2}'`
			tk=`cat $tk_file | awk -F, '{print $3}'`

			for num in `seq 1 4`; do
				cm_sn=cam${num}_sn
				cm_tk=tmp_cam${num}_tk
				if [ "$sn" = "${!cm_sn}" ]; then
					echo "$cm_tk=$tk" >> $tmp_tk
					if [ $num -eq 1 ]; then
						aa_cnt_cam1=0
					elif [ $num -eq 2 ]; then
						aa_cnt_cam2=0
					elif [ $num -eq 3 ]; then
						aa_cnt_cam3=0
					elif [ $num -eq 4 ]; then
						aa_cnt_cam4=0
					fi
				fi
			done

			# rw mount
#			/bin/mount -o rw,remount / > /dev/null
			mv $tk_file $bak_file
			sync
			# ro mount
#			/bin/mount -o ro,remount / > /dev/null
		fi
	done

	if [ -e "$tmp_tk" ]; then
		. $tmp_tk
		#echo "[`date +"%Y/%m/%d %H:%M:%S"`]" >> $dbg_log
		#cat $tmp_tk >> $dbg_log
		if [ -e $tmp_token ]; then 
			rm $tmp_token
		fi
		touch $tmp_token

		if [ -n "$tmp_scr_tk" ]; then
			if [ -z "$scr_tk" ]; then
				scr_tk=$tmp_scr_tk
				echo "scr_tk=\"$tmp_scr_tk\"" >> $tmp_token
			fi
		fi
		if [ -n "$tmp_cam1_tk" ]; then
			if [ -z "$cam1_tk" ]; then
				cam1_tk=$tmp_cam1_tk
				echo "cam1_tk=\"$tmp_cam1_tk\"" >> $tmp_token
			fi
		fi
		if [ -n "$tmp_cam2_tk" ]; then
			if [ -z "$cam2_tk" ]; then
				cam2_tk=$tmp_cam2_tk
				echo "cam2_tk=\"$tmp_cam2_tk\"" >> $tmp_token
			fi
		fi
		if [ -n "$tmp_cam3_tk" ]; then
			if [ -z "$cam3_tk" ]; then
				cam3_tk=$tmp_cam3_tk
				echo "cam3_tk=\"$tmp_cam3_tk\"" >> $tmp_token
			fi
		fi
		if [ -n "$tmp_cam4_tk" ]; then
			if [ -z "$cam4_tk" ]; then
				cam4_tk=$tmp_cam4_tk
				echo "cam4_tk=\"$tmp_cam4_tk\"" >> $tmp_token
			fi
		fi

		#. $tmp_token
		rm $tmp_tk
		rm $tmp_token
	fi

}


check_cli_sts() {
	# cli-status
	# 0: no process
	# 1: activating
	# 2: activating-fail
	# 3: activate-success
	# 4: running
	# 5: running-fail

	run_chk_cnt=`expr $run_chk_cnt + 1`
	if [ $run_chk_cnt -ge 3 ]; then
		run_chk_cnt=0
	else
		return 0
	fi

	for num in `seq 0 4`; do
		if [ $num -eq 0 ]; then
			ps | grep $prog_name | grep $board_name | grep "\-t" > /dev/null
			if [ $? -eq 1 ]; then
				tk_file=$tk_path/$scr_tk_fname
				if [ -e $tk_file ]; then
					scr_status=3
				elif [ $aa_cnt_scr -gt 3 ]; then
					scr_status=2
				else
					scr_status=1
				fi
			else
				if [ $run_cnt_scr -ge 2 ]; then
					scr_status=5
				else
					scr_status=4
				fi
				run_cnt_scr=0
			fi
		else
			ip=cam${num}_ip
			cli=${!ip}
			if [ -n "$cli" ]; then
				ps | grep $prog_name | grep "$cli" | grep "\-t" > /dev/null
				if [ $? -eq 1 ]; then
					tk_file=$tk_path/$cm_tk_fname$num
					if [ -e $tk_file ]; then
						if [ "$num" -eq 1 ]; then
							cam1_status=3
						elif [ "$num" -eq 2 ]; then
							cam2_status=3
						elif [ "$num" -eq 3 ]; then
							cam3_status=3
						elif [ "$num" -eq 4 ]; then
							cam4_status=3
						fi
					else
						if [ "$num" -eq 1 ]; then
							if [ $aa_cnt_cam1 -gt 3 ]; then
								cam1_status=2
							else
								cam1_status=1
							fi
						elif [ "$num" -eq 2 ]; then
							if [ $aa_cnt_cam2 -gt 3 ]; then
								cam2_status=2
							else
								cam2_status=1
							fi
						elif [ "$num" -eq 3 ]; then
							if [ $aa_cnt_cam3 -gt 3 ]; then
								cam3_status=2
							else
								cam3_status=1
							fi
						elif [ "$num" -eq 4 ]; then
							if [ $aa_cnt_cam4 -gt 3 ]; then
								cam4_status=2
							else
								cam4_status=1
							fi
						fi
					fi
				else
					if [ "$num" -eq 1 ]; then
						if [ $run_cnt_cam1 -ge 2 ]; then
							cam1_status=5
						else
							cam1_status=4
						fi
						run_cnt_cam1=0
					elif [ "$num" -eq 2 ]; then
						if [ $run_cnt_cam2 -ge 2 ]; then
							cam2_status=5
						else
							cam2_status=4
						fi
						run_cnt_cam2=0
					elif [ "$num" -eq 3 ]; then
						if [ $run_cnt_cam3 -ge 2 ]; then
							cam3_status=5
						else
							cam3_status=4
						fi
						run_cnt_cam3=0
					elif [ "$num" -eq 4 ]; then
						if [ $run_cnt_cam4 -ge 2 ]; then
							cam4_status=5
						else
							cam4_status=4
						fi
						run_cnt_cam4=0
					fi
				fi
			else
				if [ "$num" -eq 1 ]; then
						cam1_status=0
				elif [ "$num" -eq 2 ]; then
						cam2_status=0
				elif [ "$num" -eq 3 ]; then
						cam3_status=0
				elif [ "$num" -eq 4 ]; then
						cam4_status=0
				fi
			fi
		fi
	done

	if [ $scr_status -ne $scr_ll_sts -o \
							$cam1_status -ne $cam1_ll_sts -o $cam2_status -ne $cam2_ll_sts -o \
							$cam3_status -ne $cam3_ll_sts -o $cam4_status -ne $cam4_ll_sts ]; then
		echo "scr_status=\"$scr_status\"" > $tmp_cli_sts
		echo "cam1_status=\"$cam1_status\"" >> $tmp_cli_sts
		echo "cam2_status=\"$cam2_status\"" >> $tmp_cli_sts
		echo "cam3_status=\"$cam3_status\"" >> $tmp_cli_sts
		echo "cam4_status=\"$cam4_status\"" >> $tmp_cli_sts

		echo "scr_model=\"$scr_model\"" >> $tmp_cli_sts
		echo "scr_sn=\"$scr_sn\"" >> $tmp_cli_sts
		echo "cam1_model=\"$cam1_model\"" >> $tmp_cli_sts
		echo "cam2_model=\"$cam2_model\"" >> $tmp_cli_sts
		echo "cam3_model=\"$cam3_model\"" >> $tmp_cli_sts
		echo "cam4_model=\"$cam4_model\"" >> $tmp_cli_sts
		echo "cam1_sn=\"$cam1_sn\"" >> $tmp_cli_sts
		echo "cam2_sn=\"$cam2_sn\"" >> $tmp_cli_sts
		echo "cam3_sn=\"$cam3_sn\"" >> $tmp_cli_sts
		echo "cam4_sn=\"$cam4_sn\"" >> $tmp_cli_sts
		echo "cam1_ip=\"$cam1_ip\"" >> $tmp_cli_sts
		echo "cam2_ip=\"$cam2_ip\"" >> $tmp_cli_sts
		echo "cam3_ip=\"$cam3_ip\"" >> $tmp_cli_sts
		echo "cam4_ip=\"$cam4_ip\"" >> $tmp_cli_sts
		scr_ll_sts=$scr_status
		cam1_ll_sts=$cam1_status
		cam2_ll_sts=$cam2_status
		cam3_ll_sts=$cam3_status
		cam4_ll_sts=$cam4_status
		sync
	fi
}




set_cam_status() {
	# rw mount
#	/bin/mount -o rw,remount / > /dev/null

	camcnt=1
	for num in `seq 1 4`; do
		sn=cam_sn_$num
		ip=cam_ip_$num
		#model=cam_modelName_$num
		model=product_name_$num
		port=cam_if_$num
		mac=cam_mac_$num
		if [ -n "${!ip}" ]; then
			if [ $camcnt = 1 ]; then
				echo -n "[" > $cam_status
			else
				echo -n "," >> $cam_status
			fi
			echo -n "{" >> $cam_status

			echo -n "\"interface\":${!port}," >> $cam_status
			echo -n "\"modelid\":\"${!model}\"," >> $cam_status
			echo -n "\"serialno\":\"${!sn}\"," >> $cam_status
			echo -n "\"macaddr\":\"${!mac}\"," >> $cam_status
			echo -n "\"address\":\"${!ip}\"" >> $cam_status
			echo -n "}" >> $cam_status
			camcnt=`expr $camcnt + 1`
		fi
	done
	if [ $camcnt != 1 ]; then
		echo -n "]" >> $cam_status
	fi

	# ro mount
#	/bin/mount -o ro,remount / > /dev/null
}

update_camera() {
	# check ip-addr
	check_ip

	# scan new-cam
	reset_discover_cam
	$discover > $tmp_discover
	found_cam=`cat $tmp_discover | grep cam_sn_ | wc -l`
	echo "found_cam=$found_cam" > $tmp_cfg
	. $tmp_discover

	count_cfg_cam
	total=$?

	# check new-camera
	if [ $found_cam -ne 0 ]; then
		for n in `seq 1 $found_cam`; do
			sn=cam_sn_$n
			ip=cam_ip_$n
			#model=cam_modelName_$n
			model=product_name_$n
			port=cam_if_$n
			mac=cam_mac_$n

			if [ -z "${!ip}" ]; then
				continue
			fi

			mac_len=${!mac}
			if [ "${#mac_len}" != 17 ]; then
				#echo "mac-err $n, ${#mac_len}, ${!mac}, ${!ip}" >> $dbg_log
				continue
			fi

			check_cam_mac "${!mac}"
			if [ $? = 0 ]; then 
				#echo "found-cam $n, $total, ${!mac}, ${!ip}, ${!sn}" >> $dbg_log
				total=`expr $total + 1`
			fi
			check_regnum "${!mac}"
			num=$?
			if [ $num -ne 0 ]; then 
				echo "cam${num}_ip=\"${!ip}\"" >> $tmp_cfg
				if [ -n "${!mac}" ]; then
					echo "cam${num}_mac=\"${!mac}\"" >> $tmp_cfg
				fi
				if [ -n "${!port}" ]; then
					echo "cam${num}_port=\"${!port}\"" >> $tmp_cfg
				fi
				if [ -n "${!sn}" ]; then
					echo "cam${num}_sn=\"${!sn}\"" >> $tmp_cfg
				fi
				if [ -n "${!model}" ]; then
					echo "cam${num}_model=\"${!model}\"" >> $tmp_cfg
				fi

				tmp_user=cam${num}_user
				if [ -z "${!tmp_user}" ]; then
					echo "cam${num}_user=\"admin\"" >> $tmp_cfg
				fi

				tmp_passwd=cam${num}_passwd
				if [ -z "${!tmp_passwd}" ]; then
					echo "${!model}" | grep "VN-" > /dev/null
					if [ $? -ne 0 ]; then
						echo "cam${num}_passwd=\"admin\"" >> $tmp_cfg
					else
						echo "cam${num}_passwd=\"jvc\"" >> $tmp_cfg
					fi
				fi
				. $tmp_cfg
			fi
		done
	fi
	echo "camera_count=$total" >> $tmp_cfg
	if [ "$auto_safie" = "1" ] && [ "$total" -gt "$cam_count" ]; then
		echo "cam_count=\"$total\"" >> $tmp_cfg
	fi
	. $tmp_cfg

	check_token

	save_cam_info
	diff $cam_info $tmp_info >/dev/null 2>&1
	if [ $? -ne 0 ]; then
		cp $tmp_info $cam_info
		#bk_cfg_file=$config_path/`date +"%Y%m%d%H%M%S"`_user.cfg
		#cp $config_file $bk_cfg_file
		update_usr_cfg
		#echo -n "[`date +"%Y/%m/%d %H:%M:%S"`]" >> $dbg_log
		#echo " update user.cfg" >> $dbg_log

		# for safie-camera-status
		set_cam_status

		sync
	fi

	rm $tmp_discover
	rm $tmp_cfg
}


# $1:0scr/1,2,3,4cam, $2:model, $3:sn, $4:ip, $5:token, $6:user, $7:paswd, $8:token_save_file
run_prog() {
	#echo "dbg: run_prog 1:$1, 2:$2, 3:$3, 4:$4, 5:$5, 6:$6, 7:$7, 8:$8"
	#echo -n "[`date +"%Y/%m/%d %H:%M:%S"`]" >> $dbg_log
	#echo " run_prog 1:$1, 2:$2, 3:$3, 4:$4, 5:$5, 6:$6, 7:$7, 8:$8" >> $dbg_log

	if [ "$1" = "0" ]; then
		if [ -z "$5" ]; then
			if [ "$auto_safie" != "1" ]; then
				return 1
			fi
			aa_cnt_scr=`expr $aa_cnt_scr + 1`
			if [ -z "$2" -o -z "$3" ]; then
				return 1
			fi
			#echo "dbg: Activate router-client ($3)"
			$prog_name -m $2 -s $3 -A -F $8 &> /dev/null &
		else
			run_cnt_scr=`expr $run_cnt_scr + 1`
			if [ -z "$2" ]; then
				return 1
			fi
			#echo "dbg: re-start router-client [$5]"
			$prog_name -m $2 -t $5 &> /dev/null &
		fi
	else
		if [ -z "$5" ]; then
			if [ "$auto_safie" != "1" ]; then
				return 1
			fi
			if [ $1 = "1" ]; then
				aa_cnt_cam1=`expr $aa_cnt_cam1 + 1`
			elif [ $1 = "2" ]; then
				aa_cnt_cam2=`expr $aa_cnt_cam2 + 1`
			elif [ $1 = "3" ]; then
				aa_cnt_cam3=`expr $aa_cnt_cam3 + 1`
			elif [ $1 = "4" ]; then
				aa_cnt_cam4=`expr $aa_cnt_cam4 + 1`
			fi
			if [ -z "$2" -o -z "$3" -o -z "$4" -o -z "$6" -o -z "$7" ]; then
				return 1
			fi

			#echo "dbg: Activate camera-client ($3)"
			$prog_name -a $4 -p 80 -m $2 -s $3 -i onvif -u $6 -P $7 -A -F $8 &> /dev/null &
		else
			if [ $1 = "1" ]; then
				run_cnt_cam1=`expr $run_cnt_cam1 + 1`
			elif [ $1 = "2" ]; then
				run_cnt_cam2=`expr $run_cnt_cam2 + 1`
			elif [ $1 = "3" ]; then
				run_cnt_cam3=`expr $run_cnt_cam3 + 1`
			elif [ $1 = "4" ]; then
				run_cnt_cam4=`expr $run_cnt_cam4 + 1`
			fi
			if [ -z "$4" -o -z "$6" -o -z "$7" ]; then
				return 1
			fi

			#echo "dbg: re-start camera-client [$5]"
			$prog_name -a $4 -p 80 -t $5 -i onvif -u $6 -P $7 &> /dev/null &
		fi
	fi
	run_cli_flag=1

	return 0
}


run_router_client() {
	p_num=`ps | grep $prog_name | grep "\-m $scr_model" | wc -l`
	if [ "$scr_pid" -eq 0 ] && [ $p_num -ne 0 ]; then
		echo "dbg: already !!!!! router-cli $p_num"
		pid=`ps | grep $prog_name | grep "\-m $scr_model" | awk '{print $1}' | sed -n -e 1p`
		kill -9 "$pid"
		return 1
	fi
	if [ $p_num -gt 1 ]; then
		echo "dbg: !!!!! router-cli $p_num"
		pid=`ps | grep $prog_name | grep "\-m $scr_model" | awk '{print $1}' | sed -n -e 1p`
		kill -9 "$pid"
		return 1
	fi
	if [ -n "$scr_pid" ] && [ "$scr_pid" -ne 0 ]; then
		pid=`ps | grep $prog_name | grep "\-m $scr_model" | awk '{print $1}'`
		#echo "dbg: pid $scr_pid, pid $pid"
		if [ "$pid" = "$scr_pid" ]; then
			#echo "dbg: return router $pid"
			return 1
		else
			p_num=`ps | grep $prog_name | grep "\-m $scr_model" | wc -l`
			echo "dbg: !!!!! router-cli $p_num"
		fi
	fi

	# $1:0scr/cam, $2:model, $3:sn, $4:ip, $5:token, $6:user, $7:paswd, $8:token_save_file
	run_prog "0" "$scr_model" "$serial_number" "$scr_ip" "$scr_tk" "admin" "pass" "$scr_tk_fname"
	scr_pid=`ps | grep $prog_name | grep "\-m $scr_model" | grep -v grep | awk '{print $1}'`
	#echo "dbg: run router-cli $scr_pid"

	return 0
}


check_run_client(){
	ps | grep $prog_name | grep "\-a" | grep -E '[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}' -o > $tmp_ps_ip
	while read line; do
		ps_ip=$line
		found_flag=0
		for num in `seq 1 4`; do
			ip=cam${num}_ip
			if [ "$ps_ip" = "${!ip}" ]; then
			found_flag=1
			fi
		done

		if [ $found_flag = 0 ]; then
			pid=`ps | grep "\-a $ps_ip" | grep -v grep | awk '{print $1}'`
			if [ -n "$pid" ]; then
				#echo -n "[`date +"%Y/%m/%d %H:%M:%S"`]" >> $dbg_log
				#echo " !!! not found ip addr \"$ps_ip\", kill $pid" >> $dbg_log
				kill -KILL $pid
			fi
		fi
	done < $tmp_ps_ip
	rm $tmp_ps_ip
}


run_camera_client() {
	#echo "run camera-client $cam_count"
	if [ $cam_count -ne 0 ]; then
		#echo "dbg: cli cam1_tk: $cam1_tk"
		#echo "dbg: cli cam2_tk: $cam2_tk"
		#echo "dbg: cli cam3_tk: $cam3_tk"
		#echo "dbg: cli cam4_tk: $cam4_tk"

		for n in `seq 1 $cam_count`; do
			str_ip="cam""$n""_ip"
			if [ -z "${!str_ip}" ]; then 
				#echo "dbg: none-ip #$n"
				continue
			fi
			ps | grep $prog_name | grep "${!str_ip}" > /dev/null
			if [ $? -eq 1 ]; then 
				str_sn="cam""$n""_sn"
				str_tk="cam""$n""_tk"
				str_usr="cam""$n""_user"
				str_pw="cam""$n""_passwd"
				str_model="cam""$n""_model"
				tk_fn=${cm_tk_fname}${n}

				#echo "dbg: found ${!str_ip} $n/$cam_count"
				# $1:0scr/1,2,3,4cam, $2:model, $3:sn, $4:ip, $5:token, $6:user, $7:passwd, $8:token_save_file
				if [ -z "${!str_usr}" -o -z "${!str_pw}" ]; then
					if [ `echo ${!str_model} | grep "VN-"` ]; then
						run_prog "$n" "${!str_model}" "${!str_sn}" "${!str_ip}" "${!str_tk}" "admin" "jvc" "$tk_fn"
					else
						run_prog "$n" "${!str_model}" "${!str_sn}" "${!str_ip}" "${!str_tk}" "admin" "admin" "$tk_fn"
					fi
				else
					run_prog "$n" "${!str_model}" "${!str_sn}" "${!str_ip}" "${!str_tk}" "${!str_usr}" "${!str_pw}" "$tk_fn"
				fi

				pid=`ps | grep $prog_name | grep "${!str_ip}" | awk '{print $1}'`
				#echo "dbg: camera-client $pid"
			#	cm_fname=cm_cli$n
			#	echo "cm_model=\"${!str_model}\"" >> ${!cm_fname}
			#	echo "cm_sn=\"${!str_sn}\"" >> ${!cm_fname}
			#	echo "cm_pid=\"$pid\"" > ${!cm_fname}
			#	echo "cm_ip=\"${!str_ip}\"" >> ${!cm_fname}
			#	echo "cm_tk=\"${!str_tk}\"" >> ${!cm_fname}

			#else
				#echo "dbg: running cam-cli ${!str_ip}"
			fi
		done
	fi
}





###############################################################################
#if [ -e $dbg_log ]; then
#	rm $dbg_log
#fi

# from user.cfg 
save_cam_info

# wait camera-start-up
sleep 50

# discover & run
for loop in `seq 1 5`; do
	# scan, update cam-info
	update_camera

	run_cli_flag=0
	# start router-client
	run_router_client

	# check client-ip
	check_run_client

	# start camera-client
	run_camera_client

	#if [ $run_cli_flag -ne 0 ]; then
	#	echo "[`date +"%Y/%m/%d %H:%M:%S"`]" >> $dbg_log
	#	ps | grep $prog_name | grep -v grep >> $dbg_log
	#fi

	check_cli_sts

	sleep 3
done


# run loop
while :
do
	# check cam-info
	check_ip
	check_token

	save_cam_info
	diff $cam_info $tmp_info >/dev/null 2>&1
	if [ $? -ne 0 ]; then
		cp $tmp_info $cam_info
		#bk_cfg_file=$config_path/`date +"%Y%m%d%H%M%S"`_user.cfg
		#cp $config_file $bk_cfg_file
		update_usr_cfg
		#echo -n "[`date +"%Y/%m/%d %H:%M:%S"`]" >> $dbg_log
		#echo " update user.cfg" >> $dbg_log

		# for safie-camera-status
		set_cam_status
		sync
	fi

	run_cli_flag=0
	# start router-client
	run_router_client

	# check client-ip
	check_run_client

	# start camera-client
	run_camera_client

	#if [ $run_cli_flag -ne 0 ]; then
	#	echo "[`date +"%Y/%m/%d %H:%M:%S"`]" >> $dbg_log
	#	ps | grep $prog_name | grep -v grep >> $dbg_log
	#fi

	check_cli_sts

	sleep 60
done


exit 0

