#!/bin/sh

# get params
saveIFS=$IFS
IFS='=&'
parm=($QUERY_STRING)
IFS=$saveIFS

# store to array
declare -A array
for ((i=0; i<${#parm[@]}; i+=2))
do
    array[${parm[i]}]=${parm[i+1]}
done

config=${array[config]}


# saved user config
default_file="/etc/setup-netcfg/default/default_user.cfg"
cfg_file="/etc/setup-netcfg/user.cfg"
cfg_temp="/www/pages/user.cfg.temp"
cfg_saved="/www/pages/user.cfg"

. $default_file

if [ "$config" = "gui" ]; then
	if [ -e $cfg_temp ]; then
		. $cfg_temp
	elif [ -e $cfg_saved ]; then
		. $cfg_saved
	else
		. $cfg_file
	fi
else
	. $cfg_file
fi


# convert 0/1 to false/true for html checkbox
temp_file="/var/tmp/.temp_cbox"

list_cb="use_safie auto_safie use_wifi wlan_hidden use_easyln easyln0_en easyln1_en easyln2_en easyln3_en easyln4_en easyln5_en easyln6_en easyln7_en pf0_en pf1_en pf2_en pf3_en pf4_en pf5_en pf6_en pf7_en pf8_en pf9_en use_dhcp use_rb_ping"

for name in $list_cb; do
	if [ "${!name}" == "0" ]; then
		echo ${name}="false" >> $temp_file
	else
		echo ${name}="true"  >> $temp_file
	fi
done

# override checkbox value
. $temp_file
rm $temp_file


# output by json
echo "["

echo "{ \"id\":\"inet_if\", \"value\":\"$inet_if\" },"
echo "{ \"id\":\"inet_dhcp\", \"value\":\"$inet_dhcp\" },"
echo "{ \"id\":\"inet_address\", \"value\":\"$inet_address\" },"
echo "{ \"id\":\"inet_netmask\", \"value\":\"$inet_netmask\" },"
echo "{ \"id\":\"inet_gateway\", \"value\":\"$inet_gateway\" },"
echo "{ \"id\":\"inet_dns1\", \"value\":\"$inet_dns1\" },"
echo "{ \"id\":\"inet_dns2\", \"value\":\"$inet_dns2\" },"

echo "{ \"id\":\"lte_apn\", \"value\":\"$lte_apn\" },"
echo "{ \"id\":\"lte_user\", \"value\":\"$lte_user\" },"
echo "{ \"id\":\"lte_password\", \"value\":\"$lte_password\" },"
echo "{ \"id\":\"lte_auth\", \"value\":\"$lte_auth\" },"

echo "{ \"id\":\"use_safie\", \"value\":$use_safie },"
echo "{ \"id\":\"auto_safie\", \"value\":$auto_safie },"
echo "{ \"id\":\"cam_count\", \"value\":\"$cam_count\" },"
echo "{ \"id\":\"cam1_user\", \"value\":\"$cam1_user\" },"
echo "{ \"id\":\"cam2_user\", \"value\":\"$cam2_user\" },"
echo "{ \"id\":\"cam3_user\", \"value\":\"$cam3_user\" },"
echo "{ \"id\":\"cam4_user\", \"value\":\"$cam4_user\" },"
echo "{ \"id\":\"cam1_passwd\", \"value\":\"$cam1_passwd\" },"
echo "{ \"id\":\"cam2_passwd\", \"value\":\"$cam2_passwd\" },"
echo "{ \"id\":\"cam3_passwd\", \"value\":\"$cam3_passwd\" },"
echo "{ \"id\":\"cam4_passwd\", \"value\":\"$cam4_passwd\" },"
echo "{ \"id\":\"cam1_tk\", \"value\":\"$cam1_tk\" },"
echo "{ \"id\":\"cam2_tk\", \"value\":\"$cam2_tk\" },"
echo "{ \"id\":\"cam3_tk\", \"value\":\"$cam3_tk\" },"
echo "{ \"id\":\"cam4_tk\", \"value\":\"$cam4_tk\" },"
echo "{ \"id\":\"scr_tk\", \"value\":\"$scr_tk\" },"

echo "{ \"id\":\"cam1_mac\", \"value\":\"$cam1_mac\" },"
echo "{ \"id\":\"cam2_mac\", \"value\":\"$cam2_mac\" },"
echo "{ \"id\":\"cam3_mac\", \"value\":\"$cam3_mac\" },"
echo "{ \"id\":\"cam4_mac\", \"value\":\"$cam4_mac\" },"

echo "{ \"id\":\"cam1_ip\", \"value\":\"$cam1_ip\" },"
echo "{ \"id\":\"cam2_ip\", \"value\":\"$cam2_ip\" },"
echo "{ \"id\":\"cam3_ip\", \"value\":\"$cam3_ip\" },"
echo "{ \"id\":\"cam4_ip\", \"value\":\"$cam4_ip\" },"

echo "{ \"id\":\"use_wifi\", \"value\":$use_wifi },"
echo "{ \"id\":\"wlan_mode\", \"value\":\"$wlan_mode\" },"
echo "{ \"id\":\"wlan_ssid\", \"value\":\"$wlan_ssid\" },"
echo "{ \"id\":\"wlan_psk\", \"value\":\"$wlan_psk\" },"
echo "{ \"id\":\"wlan_proto\", \"value\":\"$wlan_proto\" },"
echo "{ \"id\":\"wlan_channel\", \"value\":\"$wlan_channel\" },"
echo "{ \"id\":\"wlan_hidden\", \"value\":$wlan_hidden },"

echo "{ \"id\":\"use_easyln\", \"value\":$use_easyln },"
echo "{ \"id\":\"easyln0_en\",   \"value\":$easyln0_en },"
echo "{ \"id\":\"easyln0_ip\",   \"value\":\"$easyln0_ip\" },"
echo "{ \"id\":\"easyln0_port\", \"value\":\"$easyln0_port\" },"
echo "{ \"id\":\"easyln0_type\", \"value\":\"$easyln0_type\" },"
echo "{ \"id\":\"easyln0_mapp\", \"value\":\"$easyln0_mapp\" },"
echo "{ \"id\":\"easyln1_en\",   \"value\":$easyln1_en },"
echo "{ \"id\":\"easyln1_ip\",   \"value\":\"$easyln1_ip\" },"
echo "{ \"id\":\"easyln1_port\", \"value\":\"$easyln1_port\" },"
echo "{ \"id\":\"easyln1_type\", \"value\":\"$easyln1_type\" },"
echo "{ \"id\":\"easyln1_mapp\", \"value\":\"$easyln1_mapp\" },"
echo "{ \"id\":\"easyln2_en\",   \"value\":$easyln2_en },"
echo "{ \"id\":\"easyln2_ip\",   \"value\":\"$easyln2_ip\" },"
echo "{ \"id\":\"easyln2_port\", \"value\":\"$easyln2_port\" },"
echo "{ \"id\":\"easyln2_type\", \"value\":\"$easyln2_type\" },"
echo "{ \"id\":\"easyln2_mapp\", \"value\":\"$easyln2_mapp\" },"
echo "{ \"id\":\"easyln3_en\",   \"value\":$easyln3_en },"
echo "{ \"id\":\"easyln3_ip\",   \"value\":\"$easyln3_ip\" },"
echo "{ \"id\":\"easyln3_port\", \"value\":\"$easyln3_port\" },"
echo "{ \"id\":\"easyln3_type\", \"value\":\"$easyln3_type\" },"
echo "{ \"id\":\"easyln3_mapp\", \"value\":\"$easyln3_mapp\" },"
echo "{ \"id\":\"easyln4_en\",   \"value\":$easyln4_en },"
echo "{ \"id\":\"easyln4_ip\",   \"value\":\"$easyln4_ip\" },"
echo "{ \"id\":\"easyln4_port\", \"value\":\"$easyln4_port\" },"
echo "{ \"id\":\"easyln4_type\", \"value\":\"$easyln4_type\" },"
echo "{ \"id\":\"easyln4_mapp\", \"value\":\"$easyln4_mapp\" },"
echo "{ \"id\":\"easyln5_en\",   \"value\":$easyln5_en },"
echo "{ \"id\":\"easyln5_ip\",   \"value\":\"$easyln5_ip\" },"
echo "{ \"id\":\"easyln5_port\", \"value\":\"$easyln5_port\" },"
echo "{ \"id\":\"easyln5_type\", \"value\":\"$easyln5_type\" },"
echo "{ \"id\":\"easyln5_mapp\", \"value\":\"$easyln5_mapp\" },"
echo "{ \"id\":\"easyln6_en\",   \"value\":$easyln6_en },"
echo "{ \"id\":\"easyln6_ip\",   \"value\":\"$easyln6_ip\" },"
echo "{ \"id\":\"easyln6_port\", \"value\":\"$easyln6_port\" },"
echo "{ \"id\":\"easyln6_type\", \"value\":\"$easyln6_type\" },"
echo "{ \"id\":\"easyln6_mapp\", \"value\":\"$easyln6_mapp\" },"
echo "{ \"id\":\"easyln7_en\",   \"value\":$easyln7_en },"
echo "{ \"id\":\"easyln7_ip\",   \"value\":\"$easyln7_ip\" },"
echo "{ \"id\":\"easyln7_port\", \"value\":\"$easyln7_port\" },"
echo "{ \"id\":\"easyln7_type\", \"value\":\"$easyln7_type\" },"
echo "{ \"id\":\"easyln7_mapp\", \"value\":\"$easyln7_mapp\" },"

echo "{ \"id\":\"pf0_en\",   \"value\":$pf0_en },"
echo "{ \"id\":\"pf0_ip\",   \"value\":\"$pf0_ip\" },"
echo "{ \"id\":\"pf0_port\", \"value\":\"$pf0_port\" },"
echo "{ \"id\":\"pf0_type\", \"value\":\"$pf0_type\" },"
echo "{ \"id\":\"pf0_mapp\", \"value\":\"$pf0_mapp\" },"
echo "{ \"id\":\"pf1_en\",   \"value\":$pf1_en },"
echo "{ \"id\":\"pf1_ip\",   \"value\":\"$pf1_ip\" },"
echo "{ \"id\":\"pf1_port\", \"value\":\"$pf1_port\" },"
echo "{ \"id\":\"pf1_type\", \"value\":\"$pf1_type\" },"
echo "{ \"id\":\"pf1_mapp\", \"value\":\"$pf1_mapp\" },"
echo "{ \"id\":\"pf2_en\",   \"value\":$pf2_en },"
echo "{ \"id\":\"pf2_ip\",   \"value\":\"$pf2_ip\" },"
echo "{ \"id\":\"pf2_port\", \"value\":\"$pf2_port\" },"
echo "{ \"id\":\"pf2_type\", \"value\":\"$pf2_type\" },"
echo "{ \"id\":\"pf2_mapp\", \"value\":\"$pf2_mapp\" },"
echo "{ \"id\":\"pf3_en\",   \"value\":$pf3_en },"
echo "{ \"id\":\"pf3_ip\",   \"value\":\"$pf3_ip\" },"
echo "{ \"id\":\"pf3_port\", \"value\":\"$pf3_port\" },"
echo "{ \"id\":\"pf3_type\", \"value\":\"$pf3_type\" },"
echo "{ \"id\":\"pf3_mapp\", \"value\":\"$pf3_mapp\" },"
echo "{ \"id\":\"pf4_en\",   \"value\":$pf4_en },"
echo "{ \"id\":\"pf4_ip\",   \"value\":\"$pf4_ip\" },"
echo "{ \"id\":\"pf4_port\", \"value\":\"$pf4_port\" },"
echo "{ \"id\":\"pf4_type\", \"value\":\"$pf4_type\" },"
echo "{ \"id\":\"pf4_mapp\", \"value\":\"$pf4_mapp\" },"
echo "{ \"id\":\"pf5_en\",   \"value\":$pf5_en },"
echo "{ \"id\":\"pf5_ip\",   \"value\":\"$pf5_ip\" },"
echo "{ \"id\":\"pf5_port\", \"value\":\"$pf5_port\" },"
echo "{ \"id\":\"pf5_type\", \"value\":\"$pf5_type\" },"
echo "{ \"id\":\"pf5_mapp\", \"value\":\"$pf5_mapp\" },"
echo "{ \"id\":\"pf6_en\",   \"value\":$pf6_en },"
echo "{ \"id\":\"pf6_ip\",   \"value\":\"$pf6_ip\" },"
echo "{ \"id\":\"pf6_port\", \"value\":\"$pf6_port\" },"
echo "{ \"id\":\"pf6_type\", \"value\":\"$pf6_type\" },"
echo "{ \"id\":\"pf6_mapp\", \"value\":\"$pf6_mapp\" },"
echo "{ \"id\":\"pf7_en\",   \"value\":$pf7_en },"
echo "{ \"id\":\"pf7_ip\",   \"value\":\"$pf7_ip\" },"
echo "{ \"id\":\"pf7_port\", \"value\":\"$pf7_port\" },"
echo "{ \"id\":\"pf7_type\", \"value\":\"$pf7_type\" },"
echo "{ \"id\":\"pf7_mapp\", \"value\":\"$pf7_mapp\" },"
echo "{ \"id\":\"pf8_en\",   \"value\":$pf8_en },"
echo "{ \"id\":\"pf8_ip\",   \"value\":\"$pf8_ip\" },"
echo "{ \"id\":\"pf8_port\", \"value\":\"$pf8_port\" },"
echo "{ \"id\":\"pf8_type\", \"value\":\"$pf8_type\" },"
echo "{ \"id\":\"pf8_mapp\", \"value\":\"$pf8_mapp\" },"
echo "{ \"id\":\"pf9_en\",   \"value\":$pf9_en },"
echo "{ \"id\":\"pf9_ip\",   \"value\":\"$pf9_ip\" },"
echo "{ \"id\":\"pf9_port\", \"value\":\"$pf9_port\" },"
echo "{ \"id\":\"pf9_type\", \"value\":\"$pf9_type\" },"
echo "{ \"id\":\"pf9_mapp\", \"value\":\"$pf9_mapp\" },"

echo "{ \"id\":\"sinp_enb_p2_safie\", \"value\":\"$sinp_enb_p2_safie\" },"
echo "{ \"id\":\"sinp_enb_p2_mail\", \"value\":\"$sinp_enb_p2_mail\" },"
echo "{ \"id\":\"sinp_typ_p2\", \"value\":\"$sinp_typ_p2\" },"
echo "{ \"id\":\"sinp_sec_p2\", \"value\":\"$sinp_sec_p2\" },"
echo "{ \"id\":\"sinp_enb_p4_safie\", \"value\":\"$sinp_enb_p4_safie\" },"
echo "{ \"id\":\"sinp_enb_p4_mail\", \"value\":\"$sinp_enb_p4_mail\" },"
echo "{ \"id\":\"sinp_typ_p4\", \"value\":\"$sinp_typ_p4\" },"
echo "{ \"id\":\"sinp_sec_p4\", \"value\":\"$sinp_sec_p4\" },"
echo "{ \"id\":\"sinp_addr_1\", \"value\":\"$sinp_addr_1\" },"
echo "{ \"id\":\"sinp_addr_2\", \"value\":\"$sinp_addr_2\" },"
echo "{ \"id\":\"sinp_addr_3\", \"value\":\"$sinp_addr_3\" },"
echo "{ \"id\":\"sinp_myaddr\", \"value\":\"$sinp_myaddr\" },"
echo "{ \"id\":\"sinp_smtp\",   \"value\":\"$sinp_smtp\" },"
echo "{ \"id\":\"sinp_user\",   \"value\":\"$sinp_user\" },"
echo "{ \"id\":\"sinp_passwd\", \"value\":\"$sinp_passwd\" },"

echo "{ \"id\":\"br0_address\", \"value\":\"$br0_address\" },"
echo "{ \"id\":\"br0_netmask\", \"value\":\"$br0_netmask\" },"
echo "{ \"id\":\"use_dhcp\", \"value\":$use_dhcp },"
echo "{ \"id\":\"dhcpd_range_start\", \"value\":\"$dhcpd_range_start\" },"
echo "{ \"id\":\"dhcpd_range_end\", \"value\":\"$dhcpd_range_end\" },"
echo "{ \"id\":\"vpn_mode\", \"value\":\"$vpn_mode\" },"
echo "{ \"id\":\"vpncl_conf\", \"value\":\"$vpncl_conf\" },"
echo "{ \"id\":\"ddns_prov\", \"value\":\"$ddns_prov\" },"
echo "{ \"id\":\"ddns_domain\", \"value\":\"$ddns_domain\" },"
echo "{ \"id\":\"ddns_user\", \"value\":\"$ddns_user\" },"
echo "{ \"id\":\"ddns_passwd\", \"value\":\"$ddns_passwd\" },"

echo "{ \"id\":\"ntp_url\", \"value\":\"$ntp_url\" },"

echo "{ \"id\":\"rb_cfg\",    \"value\":\"$rb_cfg\" },"
echo "{ \"id\":\"rb_day\",    \"value\":\"$rb_day\" },"
echo "{ \"id\":\"rb_hour\",   \"value\":\"$rb_hour\" },"
echo "{ \"id\":\"rb_minute\", \"value\":\"$rb_minute\" },"
echo "{ \"id\":\"rb_periodic_day\",   \"value\":\"$rb_periodic_day\" },"
echo "{ \"id\":\"rb_periodic_hour\",   \"value\":\"$rb_periodic_hour\" },"
echo "{ \"id\":\"rb_periodic_minute\", \"value\":\"$rb_periodic_minute\" },"

echo "{ \"id\":\"use_rb_ping\", \"value\":$use_rb_ping },"
echo "{ \"id\":\"ping_dest\",   \"value\":\"$ping_dest\" },"
echo "{ \"id\":\"ping_sec\",    \"value\":\"$ping_sec\" },"
echo "{ \"id\":\"ping_nfail\",  \"value\":\"$ping_nfail\" },"
echo "{ \"id\":\"ping_nrboot\", \"value\":\"$ping_nrboot\" }"

echo "]"
