#!/bin/sh

# get params
saveIFS=$IFS
IFS='=&'
parm=($QUERY_STRING)
IFS=$saveIFS

# store to array
declare -A array
for ((i=0; i<${#parm[@]}; i+=2))
do
    array[${parm[i]}]=${parm[i+1]}
done

action=${array[action]}

#
clist_file="/var/tmp/.clist_api"
dhcp_lease="/var/tmp/dnsmasq.leases"

# client list
ret_str="["  # start

if [ "$action" = "arp" ]; then
	. /etc/setup-netcfg/user.cfg
	br0_net=${br0_address%%.*}

	sudo /usr/bin/arp-scan -l -I br0 | grep "^$br0_net" > $clist_file
	tmp=`awk '{printf("{\"mac\":\"%s\", \"ip\":\"%s\"},\n"), $2,$1}' $clist_file`
	rm -f $clist_file
fi

if [ "$action" = "dhcp" ]; then
	tmp=`awk '{printf("{\"mac\":\"%s\", \"ip\":\"%s\"},\n"), $2,$3}' $dhcp_lease`
fi

if [ -n "$tmp" ]; then
	ret_str=${ret_str}$tmp
	ret_str=${ret_str:0:-1}
	ret_str="$ret_str""]"

	echo $ret_str
fi
