#!/bin/sh

PATH="/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin"

if [ $REQUEST_METHOD != "GET" ]; then
	exit 0
fi

# get params
saveIFS=$IFS
IFS='=&'
parm=($QUERY_STRING)
IFS=$saveIFS

# store to array
declare -A array
for ((i=0; i<${#parm[@]}; i+=2))
do
    array[${parm[i]}]=${parm[i+1]}
done

action=${array[action]}

if [ "$action" = "write" ]; then
	echo "Content-Type: text/html"
	echo ""
	echo "Writing Start"

	cp /etc/update-pkg/fw_write.sh /var/tmp/fw_write.sh
	(/var/tmp/fw_write.sh &> /dev/null)&
elif [ "$action" = "cancel" ]; then
	dir="/var/tmp/upgrade"
	mkdir -p $dir

	mount /dev/mmcblk0p3 $dir
	if [ $? -eq 0 ]; then
		. "$dir/file_list"
		fw_sign="$dir/$fw_sign"
		fw_file="$dir/$fw_file"
		initram_sign="$dir/$initram_sign"
		initram_file="$dir/$initram_file"

		rm -f dir/file_list $fw_sign $fw_file $initram_sign $initram_file $dir/scr.json
	fi
	umount $dir
	rm -rf $dir
	echo "Content-Type: text/html"
	echo ""
	echo "Clean-up firmware files"
fi

exit 0
