#!/bin/sh

# init
bcom_ip_1=""
bcom_ip_2=""
bcom_ip_3=""
bcom_ip_4=""
bcom1_valid=0
bcom2_valid=0
bcom3_valid=0
bcom4_valid=0


# discover camera
cam_info="/var/tmp/cam_info"

/usr/local/bin/discover-cam.sh > $cam_info
. $cam_info

if [ -n "$cam_manufacturer_1" ]; then
	bcom1_valid=1
	bcom_ip_1=$cam_ip_1
fi
if [ -n "$cam_manufacturer_2" ]; then
	bcom2_valid=1
	bcom_ip_2=$cam_ip_2
fi
if [ -n "$cam_manufacturer_3" ]; then
	bcom3_valid=1
	bcom_ip_3=$cam_ip_3
fi
if [ -n "$cam_manufacturer_4" ]; then
	bcom4_valid=1
	bcom_ip_4=$cam_ip_4
fi


# send camera info by json
nmap80=80
nmap554=554
echo "["
if [ $bcom1_valid -eq 1 ]; then
	echo "{ \"id\":\"easyln0_en\",     \"value\":\"1\" },"
	echo "{ \"id\":\"easyln0_ip\",     \"value\":\"$bcom_ip_1\" },"
	echo "{ \"id\":\"easyln0_port\",   \"value\":\"80\" },"
	echo "{ \"id\":\"easyln0_type\",   \"value\":\"TCP\" },"
	echo "{ \"id\":\"easyln0_mapp\",   \"value\":\"$nmap80\" },"
	echo "{ \"id\":\"easyln1_en\",     \"value\":\"1\" },"
	echo "{ \"id\":\"easyln1_ip\",     \"value\":\"$bcom_ip_1\" },"
	echo "{ \"id\":\"easyln1_type\",   \"value\":\"TCP\" },"
	echo "{ \"id\":\"easyln1_port\",   \"value\":\"554\" },"
	echo "{ \"id\":\"easyln1_mapp\",   \"value\":\"$nmap554\" }"
	len=`expr $nmap80 + 1`
	len=`expr $nmap554 + 1`
fi

if [ $bcom2_valid -eq 1 ]; then
	echo ","
	echo "{ \"id\":\"easyln2_en\",     \"value\":\"1\" },"
	echo "{ \"id\":\"easyln2_ip\",     \"value\":\"$bcom_ip_2\" },"
	echo "{ \"id\":\"easyln2_port\",   \"value\":\"80\" },"
	echo "{ \"id\":\"easyln2_type\",   \"value\":\"TCP\" },"
	echo "{ \"id\":\"easyln2_mapp\",   \"value\":\"$nmap80\" },"
	echo "{ \"id\":\"easyln3_en\",     \"value\":\"1\" },"
	echo "{ \"id\":\"easyln3_ip\",     \"value\":\"$bcom_ip_2\" },"
	echo "{ \"id\":\"easyln3_type\",   \"value\":\"TCP\" },"
	echo "{ \"id\":\"easyln3_port\",   \"value\":\"554\" },"
	echo "{ \"id\":\"easyln3_mapp\",   \"value\":\"$nmap554\" }"
	len=`expr $nmap80 + 1`
	len=`expr $nmap554 + 1`
fi
if [ $bcom3_valid -eq 1 ]; then
	echo ","
	echo "{ \"id\":\"easyln4_en\",     \"value\":\"1\" },"
	echo "{ \"id\":\"easyln4_ip\",     \"value\":\"$bcom_ip_3\" },"
	echo "{ \"id\":\"easyln4_port\",   \"value\":\"80\" },"
	echo "{ \"id\":\"easyln4_type\",   \"value\":\"TCP\" },"
	echo "{ \"id\":\"easyln4_mapp\",   \"value\":\"$nmap80\" },"
	echo "{ \"id\":\"easyln5_en\",     \"value\":\"1\" },"
	echo "{ \"id\":\"easyln5_ip\",     \"value\":\"$bcom_ip_3\" },"
	echo "{ \"id\":\"easyln5_type\",   \"value\":\"TCP\" },"
	echo "{ \"id\":\"easyln5_port\",   \"value\":\"554\" },"
	echo "{ \"id\":\"easyln5_mapp\",   \"value\":\"$nmap554\" }"
	len=`expr $nmap80 + 1`
	len=`expr $nmap554 + 1`
fi
if [ $bcom4_valid -eq 1 ]; then
	echo ","
	echo "{ \"id\":\"easyln6_en\",     \"value\":\"1\" },"
	echo "{ \"id\":\"easyln6_ip\",     \"value\":\"$bcom_ip_4\" },"
	echo "{ \"id\":\"easyln6_port\",   \"value\":\"80\" },"
	echo "{ \"id\":\"easyln6_type\",   \"value\":\"TCP\" },"
	echo "{ \"id\":\"easyln6_mapp\",   \"value\":\"$nmap80\" },"
	echo "{ \"id\":\"easyln7_en\",     \"value\":\"1\" },"
	echo "{ \"id\":\"easyln7_ip\",     \"value\":\"$bcom_ip_4\" },"
	echo "{ \"id\":\"easyln7_type\",   \"value\":\"TCP\" },"
	echo "{ \"id\":\"easyln7_port\",   \"value\":\"554\" },"
	echo "{ \"id\":\"easyln7_mapp\",   \"value\":\"$nmap554\" }"
fi
echo "]"

