#!/bin/sh

#
# output html for status
#

# get params
saveIFS=$IFS
IFS='=&'
parm=($QUERY_STRING)
IFS=$saveIFS

# store to array
declare -A array
for ((i=0; i<${#parm[@]}; i+=2))
do
    array[${parm[i]}]=${parm[i+1]}
done

do_scan=${array[scan]}


# files
cam_info="/var/tmp/cam_info"
clist_file="/var/tmp/.clist"
status_file="/var/tmp/.st_file"
safie_status="/var/tmp/temp_cli_sts"

if [ -n "$do_scan" ] && [ "$do_scan" = "1" ]; then
	./get_status.sh
	/usr/local/bin/discover-cam.sh > $cam_info
fi

# load files
. /var/tmp/hwinfo
. /etc/setup-netcfg/user.cfg
. $status_file
. $cam_info
. /etc/scr1800-release
if [ -e $safie_status ]; then
	. $safie_status
fi


#################
# output html
#################
TBL_HD='<table class="table table-condensed">'
TBL_ST='<tr><td class="col-sm-3">'
TBL_DIV='</td><td>'
TBL_END='</td><tr>'
TBL_FT='</table><hr>'

# board info
echo '<p class="text-primary">製品情報</p>'
echo $TBL_HD
echo $TBL_ST 製品バージョン $TBL_DIV $board_name $board_version $serial_number $TBL_END
echo $TBL_ST ソフトウェアバージョン $TBL_DIV $SW_VERSION $TBL_END
echo $TBL_FT

# wan info
echo '<p class="text-primary">WAN IPアドレス</p>'
echo $TBL_HD
echo $TBL_ST $wan_address $TBL_DIV $wan_netmask $TBL_END
echo $TBL_FT

# lan info
echo '<p class="text-primary">LAN IPアドレス</p>'
echo $TBL_HD
echo $TBL_ST $br0_address $TBL_DIV $br0_netmask $TBL_END
echo $TBL_FT

# lan client
echo '<p class="text-primary">LANクライアント</p>'
echo $TBL_HD
while read line
do
	echo $TBL_ST
	echo $line | awk '{print $1}'
	echo $TBL_DIV
	echo $line | awk '{print $2}'
	echo $TBL_DIV
	echo $line | awk '{for(i=3; i<=NF; i=i+1) printf("%s ", $i)}'
	echo $TBL_END
done < $clist_file
echo $TBL_FT


# lte rssi
# wlan rssi
echo '<p class="text-primary">電波状態</p>'
echo $TBL_HD
echo $TBL_ST LTE電波強度 $TBL_DIV $lte_rssi $TBL_END
echo $TBL_ST 無線LAN電波強度 $TBL_DIV $wlan_rssi $TBL_END
echo $TBL_FT

# PoE info
echo '<p class="text-primary">PoEポート情報</p>'
echo $TBL_HD
if [ -n "$cam_if_1" ]; then
	echo $TBL_ST ポート $cam_if_1 $TBL_DIV $cam_mac_1 $TBL_DIV $cam_ip_1 $TBL_END
fi
if [ -n "$cam_if_2" ]; then
	echo $TBL_ST ポート $cam_if_2 $TBL_DIV $cam_mac_2 $TBL_DIV $cam_ip_2 $TBL_END
fi
if [ -n "$cam_if_3" ]; then
	echo $TBL_ST ポート $cam_if_3 $TBL_DIV $cam_mac_3 $TBL_DIV $cam_ip_3 $TBL_END
fi
if [ -n "$cam_if_4" ]; then
	echo $TBL_ST ポート $cam_if_4 $TBL_DIV $cam_mac_4 $TBL_DIV $cam_ip_4 $TBL_END
fi
echo $TBL_FT

# safie info
s_status=""

function get_safie_status()
{
	local name=$1
	local val=${!name}

	if [ -z "$val" ]; then
		s_status="停止"
		return 1
	fi

	case "$val" in
	0)
		s_status="待機"
	;;
	1)
		s_status="トークン取得中"
	;;
	2)
		s_status="トークン取得失敗"
	;;
	3)
		s_status="トークン取得成功・映像送信中"
	;;
	4)
		s_status="映像送信中"
	;;
	5)
		s_status="映像送信エラー"
	;;
	esac

	if [ "$name" = "scr_status" ] && [ "$val" -eq 3 ]; then
		s_status="トークン取得成功・動作中"
	fi
	if [ "$name" = "scr_status" ] && [ "$val" -eq 4 ]; then
		s_status="動作中"
	fi
	if [ "$name" = "scr_status" ] && [ "$val" -eq 5 ]; then
		s_status="動作エラー"
	fi
}

echo '<p class="text-primary">Safieクライアント</p>'
echo $TBL_HD
get_safie_status "scr_status"
echo $TBL_ST SCR1800 $TBL_DIV $s_status $TBL_END
for n in `seq 1 $cam_count`; do
	str="cam""$n""_status"
	get_safie_status $str
	echo $TBL_ST カメラ $n $TBL_DIV $s_status $TBL_END
done
echo $TBL_FT


# ddns/vpn info
echo '<p class="text-primary">DynamicDNS/VPN</p>'
echo $TBL_HD
echo $TBL_ST DDNSによるドメイン名 $TBL_DIV $ddns_status $TBL_END
echo $TBL_ST OpenVPNの状態 $TBL_DIV $vpn_status $TBL_END
echo $TBL_FT

exit 0
