#!/bin/sh

VPN_CONF_PATH="/etc/openvpn"
UPLOAD_PATH="/www/pages/upload"

# server files
is_ca="no"
is_pem="no"
is_crt="no"
is_key="no"

if [ -e "${VPN_CONF_PATH}/server/ca.crt" ]; then
	is_ca="yes"
fi
if [ -e "${UPLOAD_PATH}/ca.crt" ]; then
	is_ca="up"
fi

if [ -e "${VPN_CONF_PATH}/server/dh2048.pem" ]; then
	is_pem="yes"
fi
if [ -e "${UPLOAD_PATH}/dh2048.pem" ]; then
	is_pem="up"
fi

if [ -e "${VPN_CONF_PATH}/server/server.crt" ]; then
	is_crt="yes"
fi
if [ -e "${UPLOAD_PATH}/server.crt" ]; then
	is_crt="up"
fi
if [ -e "${VPN_CONF_PATH}/server/server.key" ]; then
	is_key="yes"
fi
if [ -e "${UPLOAD_PATH}/server.key" ]; then
	is_key="up"
fi

# openvpn server file info
echo '{'
echo ' "server" : ['
echo     "{ \"id\":\"vpnsvr_ca\",   \"value\":\"$is_ca\"  },"
echo     "{ \"id\":\"vpnsvr_pem\",  \"value\":\"$is_pem\" },"
echo     "{ \"id\":\"vpnsvr_crt\",  \"value\":\"$is_crt\" },"
echo     "{ \"id\":\"vpnsvr_key\",  \"value\":\"$is_key\" }"
echo -n  ']'


# openvpn client file info
cnt=0
for file in `ls $VPN_CONF_PATH/*.conf`; do
	if [ $file != "server.conf" ]; then
		cnt=`expr $cnt + 1`
	fi
done

tmp_cnt=0
if [ $cnt -ne 0 ]; then
	echo   ','
	echo ' "client" : ['
	for file in `ls $VPN_CONF_PATH/*.conf`; do
		if [ $file != "server.conf" ]; then
			tmp=`basename $file .conf`			
			echo -n "{ \"conf\":\"$tmp\" }"

			tmp_cnt=`expr $tmp_cnt + 1`
			if [ $tmp_cnt -ne $cnt ]; then
				echo ","
			fi
		fi
	done
	
	echo   ']'
fi

# end of json
echo '}'

