#!/usr/bin/perl

use strict;
use warnings;
use JSON;

my $json_text = <STDIN>;
my $items = JSON->new()->decode($json_text);
my $count = scalar @$items;


# valid prameter
my @valid_list = (
	'inet_if', 'inet_dhcp', 'inet_address', 'inet_netmask', 'inet_gateway', 'inet_dns1', 'inet_dns2',
	'lte_apn', 'lte_user', 'lte_password', 'lte_auth',
	'use_safie', 'auto_safie', 'cam_count',
	'cam1_user', 'cam2_user', 'cam3_user', 'cam4_user',
	'cam1_passwd', 'cam2_passwd', 'cam3_passwd', 'cam4_passwd',
	'cam1_tk', 'cam2_tk', 'cam3_tk', 'cam4_tk', 'scr_tk',
	'cam1_mac', 'cam2_mac', 'cam3_mac', 'cam4_mac',
	'use_wifi', 'wlan_mode', 'wlan_ssid', 'wlan_psk', 'wlan_proto', 'wlan_channel', 'wlan_hidden',
	'use_easyln',
	'easyln0_en', 'easyln0_ip', 'easyln0_port', 'easyln0_type', 'easyln0_mapp',
	'easyln1_en', 'easyln1_ip', 'easyln1_port', 'easyln1_type', 'easyln1_mapp',
	'easyln2_en', 'easyln2_ip', 'easyln2_port', 'easyln2_type', 'easyln2_mapp',
	'easyln3_en', 'easyln3_ip', 'easyln3_port', 'easyln3_type', 'easyln3_mapp',
	'easyln4_en', 'easyln4_ip', 'easyln4_port', 'easyln4_type', 'easyln4_mapp',
	'easyln5_en', 'easyln5_ip', 'easyln5_port', 'easyln5_type', 'easyln5_mapp',
	'easyln6_en', 'easyln6_ip', 'easyln6_port', 'easyln6_type', 'easyln6_mapp',
	'easyln7_en', 'easyln7_ip', 'easyln7_port', 'easyln7_type', 'easyln7_mapp',
	'pf0_en', 'pf0_ip', 'pf0_port', 'pf0_type', 'pf0_mapp',
	'pf1_en', 'pf1_ip', 'pf1_port', 'pf1_type', 'pf1_mapp',
	'pf2_en', 'pf2_ip', 'pf2_port', 'pf2_type', 'pf2_mapp',
	'pf3_en', 'pf3_ip', 'pf3_port', 'pf3_type', 'pf3_mapp',
	'pf4_en', 'pf4_ip', 'pf4_port', 'pf4_type', 'pf4_mapp',
	'pf5_en', 'pf5_ip', 'pf5_port', 'pf5_type', 'pf5_mapp',
	'pf6_en', 'pf6_ip', 'pf6_port', 'pf6_type', 'pf6_mapp',
	'pf7_en', 'pf7_ip', 'pf7_port', 'pf7_type', 'pf7_mapp',
	'pf8_en', 'pf8_ip', 'pf8_port', 'pf8_type', 'pf8_mapp',
	'pf9_en', 'pf9_ip', 'pf9_port', 'pf9_type', 'pf9_mapp',
	'sinp_enb_p2_safie', 'sinp_enb_p2_mail', 'sinp_typ_p2', 'sinp_sec_p2', 
	'sinp_enb_p4_safie', 'sinp_enb_p4_mail', 'sinp_typ_p4', 'sinp_sec_p4',
	'sinp_addr_1', 'sinp_addr_2', 'sinp_addr_3', 'sinp_myaddr', 'sinp_smtp', 'sinp_user', 'sinp_passwd',
	'br0_address', 'br0_netmask', 'use_dhcp', 'dhcpd_range_start', 'dhcpd_range_end',
	'vpn_mode', 'vpncl_conf', 'ddns_prov', 'ddns_domain', 'ddns_user', 'ddns_passwd',
	'ntp_url', 
	'rb_cfg', 'rb_day', 'rb_hour', 'rb_minute', 'rb_periodic_day', 'rb_periodic_hour', 'rb_periodic_minute',
	'use_rb_ping', 'ping_dest', 'ping_sec', 'ping_nfail', 'ping_nrboot',
	'cam1_ip', 'cam2_ip', 'cam3_ip', 'cam4_ip',
	# temp param
	'new_passwd'
);

#
# check element count
#    172 + (1) = 173 : refer js/skkcam.js save_config()
#
if ($count > @valid_list) {
	exit(1);
}

# max value length
my $max_val_len = 64;

# output env to stdout
foreach my $item (@$items) {
	for (my $i = 0; $i < @valid_list; $i++){
		if ($item->{id} eq $valid_list[$i] and length $item->{value} < $max_val_len) {
			printf "%s=\"%s\"\n", $item->{id}, $item->{value};
		}
	}
}

exit(0);
