#!/bin/sh

# get params
saveIFS=$IFS
IFS='=&'
parm=($QUERY_STRING)
IFS=$saveIFS

# store to array
declare -A array
for ((i=0; i<${#parm[@]}; i+=2))
do
    array[${parm[i]}]=${parm[i+1]}
done

param=${array[option]}


cfg_temp="/www/pages/user.cfg.temp"
cfg_saved="/www/pages/user.cfg"

#sudo /bin/mount -o rw,remount /

# remove temporary cfg
if [ -e $cfg_temp ]; then
	rm -f $cfg_temp
fi

# check if there is uploaded cfg
if [ -e $cfg_saved ]; then
	if [ -e /www/pages/.import_cfg ]; then
		rm -f /www/pages/.import_cfg
	else
		rm -f $cfg_saved
	fi
fi

# restore factory setting
if [ "$param" = "factory_reset" ]; then
	touch /www/pages/.factory_reset
fi

/bin/sync
sudo /sbin/reboot
