/* parameter */
var MAX_CAM_NUM = 4;
var MAX_EASYLN_NUM = 8;
var MAX_PF_NUM = 10;

var last_rdata = [];
var vpncl_conf;

function read_config() {
	$("#top").fadeIn();

	$.getJSON("cgi/info_get.cgi", function(info) {
		var l = info.length;

		for(var i = 0; i < l; i++) {
			var id = info[i].id;
			if(id == "usb_eth") {
				if(info[i].value == "") {
					$("#inet_usb").remove();
				}
			} else if(id == "poe0_mac"   || id == "poe1_mac" ||
			          id == "cam_info_1" || id == "cam_info_2" ||
			          id == "cam_info_3" || id == "cam_info_4") {
				$("#" + id).text(info[i].value);
			} else {
				$('#' + id).val(info[i].value);
			}
		}

		$.getJSON("cgi/cfg_get.cgi?config=gui", function(cfg) {
			var len = cfg.length;

			for(var i = 0; i < len; i++) {
				var id = cfg[i].id;
				var inp_type = $("#" + id).attr('type');

				if (inp_type == "checkbox") {
					$("#" + id).prop("checked", cfg[i].value);
				} else if (id == "rb_cfg") {
					$("input[name='rb_cfg']").val([cfg[i].value]);
				} else {
					$('#' + id).val(cfg[i].value);
				}

				if(id == "vpncl_conf") {
					vpncl_conf = cfg[i].value;
					update_vpninfo();
				}
			}

			/* update available/disabled form */
			inet_if_select($("#inet_if").val());
			inet_dhcp_select($("#inet_dhcp").val());
			use_safie_checkbox($("#use_safie").prop("checked"));
			use_wifi_checkbox($("#use_wifi").prop("checked"));
			use_easyln_checkbox($("#use_easyln").prop("checked"));
			use_dhcp_checkbox($("#use_dhcp").prop("checked"));
			rbcfg_radio($("input[name='rb_cfg']:checked").val());
			use_rb_ping_checkbox($("#use_rb_ping").prop("checked"));
			sinput_select($("#sinp_enb_p2_mail").val(), 2);
			sinput_select($("#sinp_enb_p4_mail").val(), 4);
		});

		$.get("cgi/get_status.cgi", {scan:"0"}, function(data) {
			$("#status_content").empty();
			$("#status_content").append(data);
			$("#sending-view").fadeOut();
		});
	});
}


function verify_condition() {
	<!-- clean-up last check results -->
	$("#set_result").empty();
	for(var i = 0; i < last_rdata.length; i++) {
		$("#" + last_rdata[i].result).css("background-color","#fff");
	}

	if($("#inet_if").val() != "LTE" && $("#use_easyln").prop("checked") == true) {
		var info = '<hr><p class="lead alert alert-danger text-center">インターフェース(WAN)でLTEを選択しないとEasyLinkは使用出来ません</p>'
		$("#set_result").append(info);
		return 1;
	}

	if($("#use_wifi").prop("checked") == false && $("#inet_if").val() == "WLAN") {
		var info = '<hr><p class="lead alert alert-danger text-center">インターフェース(WAN)でWLANを選択した場合、無線LANを有効にする必要があります</p>'
		$("#set_result").append(info);
		return 1;
	}
	if($("#use_wifi").prop("checked") == true && $("#wlan_mode").val() == "AP" && $("#inet_if").val() == "WLAN") {
		var info = '<hr><p class="lead alert alert-danger text-center">インターフェース(WAN)でWLANを選択した場合、無線LANモードはSTAにする必要があります</p>'
		$("#set_result").append(info);
		return 1;
	}
	if($("#use_wifi").prop("checked") == true && $("#wlan_mode").val() == "STA" && $("#inet_if").val() != "WLAN") {
		var info = '<hr><p class="lead alert alert-danger text-center">インターフェース(WAN)でWLANを選択しない場合、無線LANモードはAPにする必要があります</p>'
		$("#set_result").append(info);
		return 1;
	}

	return 0;
}

function save_config() {
	$("#sending-view").fadeIn();

	var ret = verify_condition();
	if (ret != 0) {
		$("#sending-view").fadeOut();
		return;
	}

	var save_list = [ 'inet_if', 'inet_dhcp', 'inet_address', 'inet_netmask', 'inet_gateway', 'inet_dns1', 'inet_dns2',
	                 'lte_apn', 'lte_user', 'lte_password', 'lte_auth',

	                 'use_safie', 'auto_safie', 'cam_count',
	                 'cam1_user', 'cam2_user', 'cam3_user', 'cam4_user',
	                 'cam1_passwd', 'cam2_passwd', 'cam3_passwd', 'cam4_passwd',
	                 'cam1_tk', 'cam2_tk', 'cam3_tk', 'cam4_tk', 'scr_tk',
	                 'cam1_mac', 'cam2_mac', 'cam3_mac', 'cam4_mac',
	                 'cam1_ip', 'cam2_ip', 'cam3_ip', 'cam4_ip',

	                 'use_wifi', 'wlan_mode', 'wlan_ssid', 'wlan_psk', 'wlan_proto', 'wlan_channel', 'wlan_hidden',

	                 'use_easyln',
	                 'easyln0_en', 'easyln0_ip', 'easyln0_port', 'easyln0_type', 'easyln0_mapp',
	                 'easyln1_en', 'easyln1_ip', 'easyln1_port', 'easyln1_type', 'easyln1_mapp',
	                 'easyln2_en', 'easyln2_ip', 'easyln2_port', 'easyln2_type', 'easyln2_mapp',
	                 'easyln3_en', 'easyln3_ip', 'easyln3_port', 'easyln3_type', 'easyln3_mapp',
	                 'easyln4_en', 'easyln4_ip', 'easyln4_port', 'easyln4_type', 'easyln4_mapp',
	                 'easyln5_en', 'easyln5_ip', 'easyln5_port', 'easyln5_type', 'easyln5_mapp',
	                 'easyln6_en', 'easyln6_ip', 'easyln6_port', 'easyln6_type', 'easyln6_mapp',
	                 'easyln7_en', 'easyln7_ip', 'easyln7_port', 'easyln7_type', 'easyln7_mapp',

	                 'pf0_en', 'pf0_ip', 'pf0_port', 'pf0_type', 'pf0_mapp',
	                 'pf1_en', 'pf1_ip', 'pf1_port', 'pf1_type', 'pf1_mapp',
	                 'pf2_en', 'pf2_ip', 'pf2_port', 'pf2_type', 'pf2_mapp',
	                 'pf3_en', 'pf3_ip', 'pf3_port', 'pf3_type', 'pf3_mapp',
	                 'pf4_en', 'pf4_ip', 'pf4_port', 'pf4_type', 'pf4_mapp',
	                 'pf5_en', 'pf5_ip', 'pf5_port', 'pf5_type', 'pf5_mapp',
	                 'pf6_en', 'pf6_ip', 'pf6_port', 'pf6_type', 'pf6_mapp',
	                 'pf7_en', 'pf7_ip', 'pf7_port', 'pf7_type', 'pf7_mapp',
	                 'pf8_en', 'pf8_ip', 'pf8_port', 'pf8_type', 'pf8_mapp',
	                 'pf9_en', 'pf9_ip', 'pf9_port', 'pf9_type', 'pf9_mapp',

	                 'sinp_enb_p2_safie', 'sinp_enb_p2_mail', 'sinp_typ_p2', 'sinp_sec_p2',
	                 'sinp_enb_p4_safie', 'sinp_enb_p4_mail', 'sinp_typ_p4', 'sinp_sec_p4',
	                 'sinp_addr_1', 'sinp_addr_2', 'sinp_addr_3', 'sinp_myaddr', 'sinp_smtp', 'sinp_user', 'sinp_passwd',

	                 'br0_address', 'br0_netmask', 'use_dhcp', 'dhcpd_range_start', 'dhcpd_range_end',
	                 'vpn_mode', 'vpncl_conf', 'ddns_prov', 'ddns_domain', 'ddns_user', 'ddns_passwd', 'ntp_url',

	                 'rb_cfg', 'rb_day', 'rb_hour', 'rb_minute', 'rb_periodic_day', 'rb_periodic_hour', 'rb_periodic_minute',
	                 'use_rb_ping', 'ping_dest', 'ping_sec', 'ping_nfail', 'ping_nrboot'
	               ];

	/* update data */
	var user_cfg = [];

	for (var i in save_list) {
		var id = save_list[i];
		var inp_type = $("#" + id).attr('type');

		if (inp_type == "checkbox") {
			user_cfg.push({"id":id, "value":$('#' + id).prop("checked")});
		} else if (id == "rb_cfg") {
			user_cfg.push({"id":id, "value":$("input[name='rb_cfg']:checked").val()});
		} else {
			user_cfg.push({"id":id, "value":$('#' + id).val()});
		}
	}

	/* add info params */
	user_cfg.push({ "id":"new_passwd", "value":$("#new_passwd").val() });

	$.post("cgi/cfg_set.cgi?action=reboot&config=gui",
        JSON.stringify(user_cfg),
        function (rdata) {
			if(rdata[0].result == "ok") {
				console.log("reboot!");
				window.location.href = "reboot.html";
			} else {
				console.log("bad input");
				for(var i = 0; i < rdata.length; i++) {
					$("#" + rdata[i].result).css("background-color","#fbb");
				}
				$("#set_result").empty();
				var err_info = '<hr><p class="lead alert alert-danger text-center">設定に誤りがあります</p>'
				$("#set_result").append(err_info);
			}
			last_rdata = rdata;
        },
        "json"
    );

	$("#sending-view").fadeOut();
	console.log("sent");
}

function assign_cam_ip(n) {
	var cnum = $('#assgin_cam_no_' + n).val();
	var ip = $('#cam_ip_' + n).val();

	$('#cam' + cnum + '_ip').val(ip);
}


function update_upnp_cam_ip() {
	$("#sending-view").fadeIn();
	$.getJSON("cgi/update_cam_ip.cgi", function(data) {
		var len = data.length;

		for(var i = 0; i < len; i++) {
			if(data[i].value !=="") { 
				$('#' + data[i].id).val(data[i].value);
			}
		}
		$("#sending-view").fadeOut();
	});
}

var token_err_mess = "取得できませんでした";

function get_safie_token() {
	var url = "cgi/get_safie_token.cgi";

	$("#sending-view").fadeIn();
	$.get(url, {model:$("#cam_model").val(), sn:$("#cam_sn").val()}, function(data) {
		if(data == "") {
			$("#safie_token").val(token_err_mess);
		} else {
			$("#safie_token").val(data);
		}
		$("#sending-view").fadeOut();
	});
}

function set_safie_token() {
	var id;
	var num = $("#cam_no").val();

	if(num == "SCR1800")
		id = "scr_tk";
	else
		id = "cam" + num + "_tk";

	if($("#safie_token").val() != token_err_mess) {
		$("#" + id).val($("#safie_token").val())
	}
}


function update_easyln() {
	$("#sending-view").fadeIn();
	$.getJSON("cgi/get_easylink_info.cgi", function(data) {
		var len = data.length;

		for(var i = 0; i < 8; i++) {
			easyln_edit(i, true);
		}

		for(var i = 0; i < len; i++) {
			var name = data[i].id;

			if(name.match(/^easyln[0-7]+_en$/)) {
				if(data[i].value == "1") {
					$("#" + data[i].id).prop("checked", true);
				} else {
					$("#" + data[i].id).prop("checked", false);
				}
			} else {
				$('#' + data[i].id).val(data[i].value);
			}
		}

		for(var i = 0; i < 8; i++) {
			easyln_edit(i, false);
		}
		$("#sending-view").fadeOut();
	});
}

function save_mail_txt(sub2, sub4, body2, body4)
{
	$.post("cgi/save_mail_txt.cgi", {sub2:sub2, sub4:sub4, body2:body2, body4:body4});
}

function send_test_mail(smtp, user, passwd, myaddr, toaddr)
{
	if(toaddr != ""){
		$.get("cgi/send_test_mail.cgi", {smtp:smtp, user:user, passwd:passwd, myaddr:myaddr, toaddr:toaddr}, function(data) {
			alert("メール送信テスト：" + data);
		});
	}
}

function update_vpninfo() {
	var mode = $("#vpn_mode").val();

	$.getJSON("cgi/get_vpninfo.cgi", function(vpninfo) {
		for(var i in vpninfo['server']) {
			var id = vpninfo['server'][i].id;
			var st = vpninfo['server'][i].value;
			if(st == "yes") {
				$('#' + id).text("設定済み");
			} else if(st == "up") {
				$('#' + id).text("アップロード済み => 設定には再起動が必要");
			} else {
				$('#' + id).text("アップロードが必要");
			}
		}

		$("#vpncl_conf > option").remove();
		for(var n in vpninfo['client']) {
			var conf = vpninfo['client'][n].conf;
			$("#vpncl_conf").append($('<option>').html(conf).val(conf));
		}

		if(mode == "disable" || mode == "CLIENT") {
			$("#vpnsvr_ca").text("----");
			$("#vpnsvr_pem").text("----");
			$("#vpnsvr_crt").text("----");
			$("#vpnsvr_key").text("----");
		}

		if(vpncl_conf != "") {
			$("#vpncl_conf").val(vpncl_conf);
		}
		if(mode == "CLIENT") {
			$("#vpncl_conf").prop("disabled", false);
		} else {
			$("#vpncl_conf").prop("disabled", true);
		}
	});
}

function ovpncl_rm() {
	var conf = $("#vpncl_conf").val();

	$.get("cgi/ovpncl_rm.cgi", {conf:conf}, function(data) {
		update_vpninfo();
	});
}

function update_status() {
	$("#sending-view").fadeIn();
	$.get("cgi/get_status.cgi", {scan:"1"}, function(data) {
		$("#status_content").empty();
		$("#status_content").append(data);
		$("#sending-view").fadeOut();
	})
}

function file_upload(id)
{
    var formdata = new FormData($('#' + id).get(0));
	var cgi_url = "cgi/upload_file.cgi"

	$("#sending-view").fadeIn();

	if(id == "cfg_upload") {
		cgi_url = "cgi/cfg_upload.cgi"
	} else if(id == "ovpn") {
		cgi_url = "cgi/ovpn_upload.cgi"
	}

    $.ajax({
        url  : cgi_url,
        type : "POST",
        data : formdata,
        cache       : false,
        contentType : false,
        processData : false,
        dataType    : "html"
    })
    .done(function(data, textStatus, jqXHR){
		$("#sending-view").fadeOut();
       	alert(data);
		if(data.match(/成功/) && (id == "pkg_upload" || id == "cfg_upload")) {
			var res = confirm('今すぐ再起動しますか？');
			if(res) {
				reboot_system("normal");
			}
		}
		if(id == "ovpn" || id == "vpn_upload") {
			update_vpninfo();
		}
    })
    .fail(function(jqXHR, textStatus, errorThrown){
		$("#sending-view").fadeOut();
        alert("アップロードに失敗しました");
    });
}

function reboot_system(val) {
	var url = "cgi/reboot_system.cgi";

	$.get(url, {option:val}, function(data) {
		console.log(data);
		window.location.href = "reboot.html";
	});
}

function save_cfgfile(val) {
	var now = new Date();
	var year = now.getYear();
	var month = now.getMonth() + 1;
	var day = now.getDate();
	if(year < 2000) { year += 1900; }
	if(month < 10) { month = "0" + month; }
	if(day < 10) { day = "0" + day; }

	var xhr = new XMLHttpRequest();
	xhr.open("GET", "cgi/cfg_download.cgi", true);
	xhr.responseType = "blob";
	xhr.onload = function() {
		var blob = this.response;
		if (navigator.appVersion.toString().indexOf('.NET') > 0) {
			var fileName = "scr" + year + month + day + "cfg.dat";
			window.navigator.msSaveBlob(blob, fileName);
		} else {
			var link = document.createElement('a');
			link.download = "scr" + year + month + day + "cfg.dat";
			link.href = window.URL.createObjectURL(blob);
			document.body.appendChild(link);
			link.click();
		}
	};
	xhr.send();
}

function do_ping_test(val) {
	var url = "cgi/test_ping.cgi";

	$.get(url, {addr:val}, function(data) {
		if(data == "ok") {
        	alert("pingに成功しました");
		} else {
        	alert("pingに失敗しました");
		}
	});
}

<!-- active/inactive control -->
function inet_if_select(value) {
	var mode = true;

	if(value == "LTE") {
		mode = false;
	}
	$("#lte_apn").prop("disabled", mode);
	$("#lte_user").prop("disabled", mode);
	$("#lte_password").prop("disabled", mode);
	$("#lte_auth").prop("disabled", mode);
}

function inet_dhcp_select(value) {
	var mode = true;

	if(value == "STATIC") {
		mode = false;
	}
	$("#inet_address").prop("disabled", mode);
	$("#inet_netmask").prop("disabled", mode);
	$("#inet_gateway").prop("disabled", mode);
	$("#inet_dns1").prop("disabled", mode);
	$("#inet_dns2").prop("disabled", mode);
}

function use_safie_checkbox(value) {
	var mode = true;

	if(value) {
		mode = false;
	} else {
		$("#auto_safie").prop("checked", false);
	}
	$("#auto_safie").prop("disabled", mode);
	$("#scr_tk").prop("disabled", mode);
	$("#cam1_tk").prop("disabled", mode);
	$("#cam2_tk").prop("disabled", mode);
	$("#cam3_tk").prop("disabled", mode);
	$("#cam4_tk").prop("disabled", mode);
	$("#cam1_user").prop("disabled", mode);
	$("#cam2_user").prop("disabled", mode);
	$("#cam3_user").prop("disabled", mode);
	$("#cam4_user").prop("disabled", mode);
	$("#cam1_passwd").prop("disabled", mode);
	$("#cam2_passwd").prop("disabled", mode);
	$("#cam3_passwd").prop("disabled", mode);
	$("#cam4_passwd").prop("disabled", mode);

	$("#cam_count").prop("disabled", mode);
	$("#cam_update_ip").prop("disabled", mode);
	$("#cam1_ip").prop("disabled", mode);
	$("#cam2_ip").prop("disabled", mode);
	$("#cam3_ip").prop("disabled", mode);
	$("#cam4_ip").prop("disabled", mode);
	$("#safie_tk_btn").prop("disabled", mode);

	cam_count_select($("#cam_count").val());

	/* sinput select */
	if(value) {
		$("#sinp_safie_p2").removeAttr("disabled");
		$("#sinp_safie_p4").removeAttr("disabled");
	} else {
		$("#sinp_safie_p2").attr("disabled", "disabled");
		$("#sinp_safie_p4").attr("disabled", "disabled");
	}
}

function cam_count_select(value) {
	var mode = true;
	var cnt = MAX_CAM_NUM;

	for(var i = 1; i <= MAX_CAM_NUM; i++) {
		$("#cam" + i + "_tk").prop("disabled", true);
		$("#cam" + i + "_ip").prop("disabled", true);
		$("#cam" + i + "_user").prop("disabled", true);
		$("#cam" + i + "_passwd").prop("disabled", true);
	}

	if($("#use_safie").prop("checked")) {
		mode = false;
		cnt = value;
	}
	
	for(var i = 1; i <= cnt; i++) {
		$("#cam" + i + "_tk").prop("disabled", mode);
		$("#cam" + i + "_ip").prop("disabled", mode);
		$("#cam" + i + "_user").prop("disabled", mode);
		$("#cam" + i + "_passwd").prop("disabled", mode);
	}
}

function use_wifi_checkbox(value) {
	var mode = true;

	if(value) {
		mode = false;
	}
	$("#wlan_mode").prop("disabled", mode);
	$("#wlan_ssid").prop("disabled", mode);
	$("#wlan_psk").prop("disabled", mode);
	$("#wlan_proto").prop("disabled", mode);
	$("#wlan_channel").prop("disabled", mode);
	$("#wlan_hidden").prop("disabled", mode);

	wlan_mode_select($("#wlan_mode").val());
}

function wlan_mode_select(value) {
	var mode = true;

	if($("#use_wifi").prop("checked") && value == "AP") {
		mode = false;
	}
	$("#wlan_channel").prop("disabled", mode);
	$("#wlan_hidden").prop("disabled", mode);
}

function use_easyln_checkbox(value) {
	if(!value) {
		for(var i = 0; i < 8; i++) {
			$("#easyln" + i + "_en").prop("checked", false);
		}
		$("#update_easyln").prop("disabled", true);
	} else {
		$("#update_easyln").prop("disabled", false);
	}
}

function easyln_edit(n, value) {
	var mode = true;

	if(value) {
		mode = false;
	}
	$("#easyln" + n + "_ip").prop("disabled", mode);
	$("#easyln" + n + "_port").prop("disabled", mode);
	$("#easyln" + n + "_type").prop("disabled", mode);
	$("#easyln" + n + "_mapp").prop("disabled", mode);
}

function ddns_prov_select(value) {
	var mode = true;

	if(value != "disable") {
		mode = false;
	}
	$("#ddns_domain").prop("disabled", mode);
	$("#ddns_user").prop("disabled", mode);
	$("#ddns_passwd").prop("disabled", mode);
}

function use_dhcp_checkbox(value) {
	var mode = true;

	if(value) {
		mode = false;
	}
	$("#dhcpd_range_start").prop("disabled", mode);
	$("#dhcpd_range_end").prop("disabled", mode);
}

function update_pw_checkbox(value) {
	if(value) {
		$("#new_passwd").prop("disabled", false);
	} else {
		$("#new_passwd").val("");
		$("#new_passwd").prop("disabled", true);
	}
}

function sinput_select(value, pin) {
	var mode = true;

	if(value == "enable") {
		mode = false;
	}
	$("#sinp_sub_p" + pin).prop("disabled", mode);
	$("#sinp_body_p" + pin).prop("disabled", mode);
}

function rbcfg_radio(value) {
	if(value == "month") {
		$("#rb_day").prop("disabled", false);
		$("#rb_hour").prop("disabled", false);
		$("#rb_minute").prop("disabled", false);
		$("#rb_periodic_day").prop("disabled", true);
		$("#rb_periodic_hour").prop("disabled", true);
		$("#rb_periodic_minute").prop("disabled", true);
	} else if(value == "periodic_day") {
		$("#rb_day").prop("disabled", true);
		$("#rb_hour").prop("disabled", true);
		$("#rb_minute").prop("disabled", true);
		$("#rb_periodic_day").prop("disabled", false);
		$("#rb_periodic_hour").prop("disabled", false);
		$("#rb_periodic_minute").prop("disabled", false);
	} else {/*disable*/
		$("#rb_day").prop("disabled", true);
		$("#rb_hour").prop("disabled", true);
		$("#rb_minute").prop("disabled", true);
		$("#rb_periodic_day").prop("disabled", true);
		$("#rb_periodic_hour").prop("disabled", true);
		$("#rb_periodic_minute").prop("disabled", true);
	}
}

function use_rb_ping_checkbox(value) {
	var mode = true;

	if(value) {
		mode = false;
	}
	$("#ping_dest").prop("disabled", mode);
	$("#ping_sec").prop("disabled", mode);
	$("#ping_nfail").prop("disabled", mode);
	$("#ping_nrboot").prop("disabled", mode);
}


function fw_upload() {
	var formdata = new FormData($('#fw_upgrade').get(0));
	if(confirm("ファームウェアをアップロードします。\n処理には数分かかります。") == false){
		return;
	}

	$("#prog").fadeIn();
	$("button").prop("disabled", true);
	$.ajax({
		url  : "cgi/fw_upload.cgi",
		type : "POST",
		data : formdata,
		cache	   : false,
		timeout	 : 1200000,
		dataType	: "html",
		contentType : false,
		processData : false,
		xhr : function(){
			var XHR = $.ajaxSettings.xhr();
			XHR.upload.addEventListener('progress',function(e){
				var progre = parseInt(e.loaded/e.total * 100);
				$('#progbar').val(progre);
				if(progre == 100) {
					$('#progtext').text("もうしばらくお待ちください...");
				}
			});
			return XHR;
		}
	})
	.done(function(data, textStatus, jqXHR){
		$('#progtext').text("アップロード...");
		alert(data);
		$("#prog").fadeOut();
		$("button").prop("disabled", false);
		if(data.match(/成功/)) {
			if(confirm("ファームウェアを書き換えて再起動しますか？\n処理には数分かかります。") == false){
				$.get("cgi/fw_upgrade.cgi", {action:"cancel"}, function(data){
					alert(data);
				}).fail(function(){alert("network error")});
			} else {
				var fw_url = 'fw_upgrade.html?addr=';
				fw_url += $("#br0_address").val();
				$.get("cgi/fw_upgrade.cgi", {action:"write"}, function(data){
					if(data.match(/Start/)) {
						window.location.href = fw_url;
					} else {
						alert(data);
					}
				}).fail(function(){alert("network error")});
			}
		}
	})
	.fail(function(jqXHR, textStatus, errorThrown){
		$('#progtext').text("アップロード...");
		$("#prog").fadeOut();
		$("button").prop("disabled", false);
		alert("アップロードに失敗しました");
	});
}
